/*-------------------------------------------------------------------*/
/* LPC15xx Register Definitions and Cortex-M3 Supplement Definitions */
/*       This file is a non-copyrighted public domain software       */
/*-------------------------------------------------------------------*/

#ifndef __LPC15xx
#define __LPC15xx
#include <stdint.h>

#define	USE_SV_SERVICE	0	/* Enable supervisor service for user mode task */


/* SYSCON */
#define SYSTEMREMAP		(*(volatile uint32_t*)0x40074000)
#define AHBBUFEN0		(*(volatile uint32_t*)0x4007400C)
#define AHBBUFEN1		(*(volatile uint32_t*)0x40074010)
#define SYSTCKCAL		(*(volatile uint32_t*)0x40074014)
#define NMISRC			(*(volatile uint32_t*)0x4007401C)
#define SYSRSTSTAT		(*(volatile uint32_t*)0x40074040)
#define PRESETCTRL0		(*(volatile uint32_t*)0x40074044)
#define PRESETCTRL1		(*(volatile uint32_t*)0x40074048)
#define PIOPORCAP0		(*(volatile uint32_t*)0x4007404C)
#define PIOPORCAP1		(*(volatile uint32_t*)0x40074050)
#define PIOPORCAP2		(*(volatile uint32_t*)0x40074054)
#define MAINCLKSELA		(*(volatile uint32_t*)0x40074080)
#define MAINCLKSELB		(*(volatile uint32_t*)0x40074084)
#define USBCLKSEL		(*(volatile uint32_t*)0x40074088)
#define ADCASYNCCLKSEL	(*(volatile uint32_t*)0x4007408C)
#define CLKOUTSELA		(*(volatile uint32_t*)0x40074094)
#define CLKOUTSELB		(*(volatile uint32_t*)0x40074098)
#define SYSPLLCLKSEL	(*(volatile uint32_t*)0x400740A0)
#define USBPLLCLKSEL	(*(volatile uint32_t*)0x400740A4)
#define SCTPLLCLKSEL	(*(volatile uint32_t*)0x400740A8)
#define SYSAHBCLKDIV	(*(volatile uint32_t*)0x400740C0)
#define SYSAHBCLKCTRL0	(*(volatile uint32_t*)0x400740C4)
#define SYSAHBCLKCTRL1	(*(volatile uint32_t*)0x400740C8)
#define SYSTICKCLKDIV	(*(volatile uint32_t*)0x400740CC)
#define UARTCLKDIV		(*(volatile uint32_t*)0x400740D0)
#define IOCONCLKDIV		(*(volatile uint32_t*)0x400740D4)
#define TRACECLKDIV		(*(volatile uint32_t*)0x400740D8)
#define USBCLKDIV		(*(volatile uint32_t*)0x400740EC)
#define ADCASYNCCLKDIV	(*(volatile uint32_t*)0x400740F0)
#define CLKOUTDIV		(*(volatile uint32_t*)0x400740F8)
#define FREQMECTRL		(*(volatile uint32_t*)0x40074120)
#define FLASHCFG		(*(volatile uint32_t*)0x40074124)
#define FRGCTRL			(*(volatile uint32_t*)0x40074128)
#define USBCLKCTRL		(*(volatile uint32_t*)0x4007412C)
#define USBCLKST		(*(volatile uint32_t*)0x40074130)
#define BODCTRL			(*(volatile uint32_t*)0x40074180)
#define IRCCTRL			(*(volatile uint32_t*)0x40074184)
#define SYSOSCCTRL		(*(volatile uint32_t*)0x40074188)
#define RTCOSCCTRL		(*(volatile uint32_t*)0x40074190)
#define SYSPLLCTRL		(*(volatile uint32_t*)0x40074198)
#define SYSPLLSTAT		(*(volatile uint32_t*)0x4007419C)
#define USBPLLCTRL		(*(volatile uint32_t*)0x400741A0)
#define USBPLLSTAT		(*(volatile uint32_t*)0x400741A4)
#define SCTPLLCTRL		(*(volatile uint32_t*)0x400741A8)
#define SCTPLLSTAT		(*(volatile uint32_t*)0x400741AC)
#define PDAWAKECFG		(*(volatile uint32_t*)0x40074204)
#define PDRUNCFG		(*(volatile uint32_t*)0x40074208)
#define STARTERP0		(*(volatile uint32_t*)0x40074218)
#define STARTERP1		(*(volatile uint32_t*)0x4007421C)
#define JTAG_IDCODE		(*(volatile uint32_t*)0x400743F4)
#define DEVICE_ID0		(*(volatile uint32_t*)0x400743F8)
#define DEVICE_ID1		(*(volatile uint32_t*)0x400743FC)

/* PMU */
#define PCON		(*(volatile uint32_t*)0x4003C000)
#define GPREG1		(*(volatile uint32_t*)0x4003C004)
#define GPREG2		(*(volatile uint32_t*)0x4003C008)
#define GPREG3		(*(volatile uint32_t*)0x4003C00C)
#define GPREG4		(*(volatile uint32_t*)0x4003C010)
#define GPREG5		(*(volatile uint32_t*)0x4003C014)

/* SWM */
#define PINASSIGN	( (volatile uint32_t*)0x40038000)
#define PINASSIGN0	(*(volatile uint32_t*)0x40038000)
#define PINASSIGN1	(*(volatile uint32_t*)0x40038004)
#define PINASSIGN2	(*(volatile uint32_t*)0x40038008)
#define PINASSIGN3	(*(volatile uint32_t*)0x4003800C)
#define PINASSIGN4	(*(volatile uint32_t*)0x40038010)
#define PINASSIGN5	(*(volatile uint32_t*)0x40038014)
#define PINASSIGN6	(*(volatile uint32_t*)0x40038018)
#define PINASSIGN7	(*(volatile uint32_t*)0x4003801C)
#define PINASSIGN8	(*(volatile uint32_t*)0x40038020)
#define PINASSIGN9	(*(volatile uint32_t*)0x40038024)
#define PINASSIGN10	(*(volatile uint32_t*)0x40038028)
#define PINASSIGN11	(*(volatile uint32_t*)0x4003802C)
#define PINASSIGN12	(*(volatile uint32_t*)0x40038030)
#define PINASSIGN13	(*(volatile uint32_t*)0x40038034)
#define PINASSIGN14	(*(volatile uint32_t*)0x40038038)
#define PINASSIGN15	(*(volatile uint32_t*)0x4003803C)
#define PINENABLE	( (volatile uint32_t*)0x400381C0)
#define PINENABLE0	(*(volatile uint32_t*)0x400381C0)
#define PINENABLE1	(*(volatile uint32_t*)0x400381C4)

/* INPUT MUX */
#define SCT0_INMUX		( (volatile uint32_t*)0x40014000)
#define SCT0_INMUX0		(*(volatile uint32_t*)0x40014000)
#define SCT0_INMUX1		(*(volatile uint32_t*)0x40014004)
#define SCT0_INMUX2		(*(volatile uint32_t*)0x40014008)
#define SCT0_INMUX3		(*(volatile uint32_t*)0x4001400C)
#define SCT0_INMUX4		(*(volatile uint32_t*)0x40014010)
#define SCT0_INMUX5		(*(volatile uint32_t*)0x40014014)
#define SCT0_INMUX6		(*(volatile uint32_t*)0x40014018)
#define SCT1_INMUX		( (volatile uint32_t*)0x40074020)
#define SCT1_INMUX0		(*(volatile uint32_t*)0x40074020)
#define SCT1_INMUX1		(*(volatile uint32_t*)0x40074024)
#define SCT1_INMUX2		(*(volatile uint32_t*)0x40074028)
#define SCT1_INMUX3		(*(volatile uint32_t*)0x4007402C)
#define SCT1_INMUX4		(*(volatile uint32_t*)0x40074030)
#define SCT1_INMUX5		(*(volatile uint32_t*)0x40074034)
#define SCT1_INMUX6		(*(volatile uint32_t*)0x40074038)
#define SCT2_INMUX		( (volatile uint32_t*)0x40014040)
#define SCT2_INMUX0		(*(volatile uint32_t*)0x40014040)
#define SCT2_INMUX1		(*(volatile uint32_t*)0x40014044)
#define SCT2_INMUX2		(*(volatile uint32_t*)0x40014048)
#define SCT3_INMUX		( (volatile uint32_t*)0x40014060)
#define SCT3_INMUX0		(*(volatile uint32_t*)0x40014060)
#define SCT3_INMUX1		(*(volatile uint32_t*)0x40014064)
#define SCT3_INMUX2		(*(volatile uint32_t*)0x40014068)
#define PINTSEL 		( (volatile uint32_t*)0x400140C0)
#define PINTSEL0		(*(volatile uint32_t*)0x400140C0)
#define PINTSEL1		(*(volatile uint32_t*)0x400140C4)
#define PINTSEL2		(*(volatile uint32_t*)0x400140C8)
#define PINTSEL3		(*(volatile uint32_t*)0x400140CC)
#define PINTSEL4		(*(volatile uint32_t*)0x400140D0)
#define PINTSEL5		(*(volatile uint32_t*)0x400140D4)
#define PINTSEL6		(*(volatile uint32_t*)0x400140D8)
#define PINTSEL7		(*(volatile uint32_t*)0x400140DC)
#define DMA_ITRIG_INMUX		( (volatile uint32_t*)0x400140E0)
#define DMA_ITRIG_INMUX0	(*(volatile uint32_t*)0x400140E0)
#define DMA_ITRIG_INMUX1	(*(volatile uint32_t*)0x400140E4)
#define DMA_ITRIG_INMUX2	(*(volatile uint32_t*)0x400140E8)
#define DMA_ITRIG_INMUX3	(*(volatile uint32_t*)0x400140EC)
#define DMA_ITRIG_INMUX4	(*(volatile uint32_t*)0x400140F0)
#define DMA_ITRIG_INMUX5	(*(volatile uint32_t*)0x400140F4)
#define DMA_ITRIG_INMUX6	(*(volatile uint32_t*)0x400140F8)
#define DMA_ITRIG_INMUX7	(*(volatile uint32_t*)0x400140FC)
#define DMA_ITRIG_INMUX8	(*(volatile uint32_t*)0x40014100)
#define DMA_ITRIG_INMUX9	(*(volatile uint32_t*)0x40014104)
#define DMA_ITRIG_INMUX10	(*(volatile uint32_t*)0x40014108)
#define DMA_ITRIG_INMUX11	(*(volatile uint32_t*)0x4001410C)
#define DMA_ITRIG_INMUX12	(*(volatile uint32_t*)0x40014110)
#define DMA_ITRIG_INMUX13	(*(volatile uint32_t*)0x40014114)
#define DMA_ITRIG_INMUX14	(*(volatile uint32_t*)0x40014118)
#define DMA_ITRIG_INMUX15	(*(volatile uint32_t*)0x4001411C)
#define DMA_ITRIG_INMUX16	(*(volatile uint32_t*)0x40014120)
#define DMA_ITRIG_INMUX17	(*(volatile uint32_t*)0x40014124)
#define DMA_INMUX_INMUX		( (volatile uint32_t*)0x40014140)
#define DMA_INMUX_INMUX0	(*(volatile uint32_t*)0x40014140)
#define DMA_INMUX_INMUX1	(*(volatile uint32_t*)0x40014144)
#define DMA_INMUX_INMUX2	(*(volatile uint32_t*)0x40014148)
#define DMA_INMUX_INMUX3	(*(volatile uint32_t*)0x4001414C)
#define	FREQMEAS_REF		(*(volatile uint32_t*)0x40014160)
#define	FREQMEAS_TARGET		(*(volatile uint32_t*)0x40014164)

/* IOCON */
#define PIO0_0		(*(volatile uint32_t*)0x400F8000)
#define PIO0_1		(*(volatile uint32_t*)0x400F8004)
#define PIO0_2		(*(volatile uint32_t*)0x400F8008)
#define PIO0_3		(*(volatile uint32_t*)0x400F800C)
#define PIO0_4		(*(volatile uint32_t*)0x400F8010)
#define PIO0_5		(*(volatile uint32_t*)0x400F8014)
#define PIO0_6		(*(volatile uint32_t*)0x400F8018)
#define PIO0_7		(*(volatile uint32_t*)0x400F801C)
#define PIO0_8		(*(volatile uint32_t*)0x400F8020)
#define PIO0_9		(*(volatile uint32_t*)0x400F8024)
#define PIO0_10		(*(volatile uint32_t*)0x400F8028)
#define PIO0_11		(*(volatile uint32_t*)0x400F802C)
#define PIO0_12		(*(volatile uint32_t*)0x400F8030)
#define PIO0_13		(*(volatile uint32_t*)0x400F8034)
#define PIO0_14		(*(volatile uint32_t*)0x400F8038)
#define PIO0_15		(*(volatile uint32_t*)0x400F803C)
#define PIO0_16		(*(volatile uint32_t*)0x400F8040)
#define PIO0_17		(*(volatile uint32_t*)0x400F8044)
#define PIO0_18		(*(volatile uint32_t*)0x400F8048)
#define PIO0_19		(*(volatile uint32_t*)0x400F804C)
#define PIO0_20		(*(volatile uint32_t*)0x400F8050)
#define PIO0_21		(*(volatile uint32_t*)0x400F8054)
#define PIO0_22		(*(volatile uint32_t*)0x400F8058)
#define PIO0_23		(*(volatile uint32_t*)0x400F805C)
#define PIO0_24		(*(volatile uint32_t*)0x400F8060)
#define PIO0_25		(*(volatile uint32_t*)0x400F8064)
#define PIO0_26		(*(volatile uint32_t*)0x400F8068)
#define PIO0_27		(*(volatile uint32_t*)0x400F806C)
#define PIO0_28		(*(volatile uint32_t*)0x400F8070)
#define PIO0_29		(*(volatile uint32_t*)0x400F8074)
#define PIO0_30		(*(volatile uint32_t*)0x400F8078)
#define PIO0_31		(*(volatile uint32_t*)0x400F807C)
#define PIO1_0		(*(volatile uint32_t*)0x400F8080)
#define PIO1_1		(*(volatile uint32_t*)0x400F8084)
#define PIO1_2		(*(volatile uint32_t*)0x400F8088)
#define PIO1_3		(*(volatile uint32_t*)0x400F808C)
#define PIO1_4		(*(volatile uint32_t*)0x400F8090)
#define PIO1_5		(*(volatile uint32_t*)0x400F8094)
#define PIO1_6		(*(volatile uint32_t*)0x400F8098)
#define PIO1_7		(*(volatile uint32_t*)0x400F809C)
#define PIO1_8		(*(volatile uint32_t*)0x400F80A0)
#define PIO1_9		(*(volatile uint32_t*)0x400F80A4)
#define PIO1_10		(*(volatile uint32_t*)0x400F80A8)
#define PIO1_11		(*(volatile uint32_t*)0x400F80AC)
#define PIO1_12		(*(volatile uint32_t*)0x400F80B0)
#define PIO1_13		(*(volatile uint32_t*)0x400F80B4)
#define PIO1_14		(*(volatile uint32_t*)0x400F80B8)
#define PIO1_15		(*(volatile uint32_t*)0x400F80BC)
#define PIO1_16		(*(volatile uint32_t*)0x400F80C0)
#define PIO1_17		(*(volatile uint32_t*)0x400F80C4)
#define PIO1_18		(*(volatile uint32_t*)0x400F80C8)
#define PIO1_19		(*(volatile uint32_t*)0x400F80CC)
#define PIO1_20		(*(volatile uint32_t*)0x400F80D0)
#define PIO1_21		(*(volatile uint32_t*)0x400F80D4)
#define PIO1_22		(*(volatile uint32_t*)0x400F80D8)
#define PIO1_23		(*(volatile uint32_t*)0x400F80DC)
#define PIO1_24		(*(volatile uint32_t*)0x400F80E0)
#define PIO1_25		(*(volatile uint32_t*)0x400F80E4)
#define PIO1_26		(*(volatile uint32_t*)0x400F80E8)
#define PIO1_27		(*(volatile uint32_t*)0x400F80EC)
#define PIO1_28		(*(volatile uint32_t*)0x400F80F0)
#define PIO1_29		(*(volatile uint32_t*)0x400F80F4)
#define PIO1_30		(*(volatile uint32_t*)0x400F80F8)
#define PIO1_31		(*(volatile uint32_t*)0x400F80FC)
#define PIO2_0		(*(volatile uint32_t*)0x400F8100)
#define PIO2_1		(*(volatile uint32_t*)0x400F8104)
#define PIO2_2		(*(volatile uint32_t*)0x400F8108)
#define PIO2_3		(*(volatile uint32_t*)0x400F810C)
#define PIO2_4		(*(volatile uint32_t*)0x400F8110)
#define PIO2_5		(*(volatile uint32_t*)0x400F8114)
#define PIO2_6		(*(volatile uint32_t*)0x400F8118)
#define PIO2_7		(*(volatile uint32_t*)0x400F811C)
#define PIO2_8		(*(volatile uint32_t*)0x400F8120)
#define PIO2_9		(*(volatile uint32_t*)0x400F8124)
#define PIO2_10		(*(volatile uint32_t*)0x400F8128)
#define PIO2_11		(*(volatile uint32_t*)0x400F812C)
#define PIO2_12		(*(volatile uint32_t*)0x400F8130)
#define PIO2_13		(*(volatile uint32_t*)0x400F8134)

/* GPIO */
#define GPIO_B		( (volatile uint8_t*)0x1C000000)
#define GPIO_B0		(*(volatile uint8_t*)0x1C000000)
#define GPIO_B1		(*(volatile uint8_t*)0x1C000001)
#define GPIO_B2		(*(volatile uint8_t*)0x1C000002)
#define GPIO_B3		(*(volatile uint8_t*)0x1C000003)
#define GPIO_B4		(*(volatile uint8_t*)0x1C000004)
#define GPIO_B5		(*(volatile uint8_t*)0x1C000005)
#define GPIO_B6		(*(volatile uint8_t*)0x1C000006)
#define GPIO_B7		(*(volatile uint8_t*)0x1C000007)
#define GPIO_B8		(*(volatile uint8_t*)0x1C000008)
#define GPIO_B9		(*(volatile uint8_t*)0x1C000009)
#define GPIO_B10	(*(volatile uint8_t*)0x1C00000A)
#define GPIO_B11	(*(volatile uint8_t*)0x1C00000B)
#define GPIO_B12	(*(volatile uint8_t*)0x1C00000C)
#define GPIO_B13	(*(volatile uint8_t*)0x1C00000D)
#define GPIO_B14	(*(volatile uint8_t*)0x1C00000E)
#define GPIO_B15	(*(volatile uint8_t*)0x1C00000F)
#define GPIO_B16	(*(volatile uint8_t*)0x1C000010)
#define GPIO_B17	(*(volatile uint8_t*)0x1C000011)
#define GPIO_B18	(*(volatile uint8_t*)0x1C000012)
#define GPIO_B19	(*(volatile uint8_t*)0x1C000013)
#define GPIO_B20	(*(volatile uint8_t*)0x1C000014)
#define GPIO_B21	(*(volatile uint8_t*)0x1C000015)
#define GPIO_B22	(*(volatile uint8_t*)0x1C000016)
#define GPIO_B23	(*(volatile uint8_t*)0x1C000017)
#define GPIO_B24	(*(volatile uint8_t*)0x1C000018)
#define GPIO_B25	(*(volatile uint8_t*)0x1C000019)
#define GPIO_B26	(*(volatile uint8_t*)0x1C00001A)
#define GPIO_B27	(*(volatile uint8_t*)0x1C00001B)
#define GPIO_B28	(*(volatile uint8_t*)0x1C00001C)
#define GPIO_B29	(*(volatile uint8_t*)0x1C00001D)
#define GPIO_B30	(*(volatile uint8_t*)0x1C00001E)
#define GPIO_B31	(*(volatile uint8_t*)0x1C00001F)
#define GPIO_B32	(*(volatile uint8_t*)0x1C000020)
#define GPIO_B33	(*(volatile uint8_t*)0x1C000021)
#define GPIO_B34	(*(volatile uint8_t*)0x1C000022)
#define GPIO_B35	(*(volatile uint8_t*)0x1C000023)
#define GPIO_B36	(*(volatile uint8_t*)0x1C000024)
#define GPIO_B37	(*(volatile uint8_t*)0x1C000025)
#define GPIO_B38	(*(volatile uint8_t*)0x1C000026)
#define GPIO_B39	(*(volatile uint8_t*)0x1C000027)
#define GPIO_B40	(*(volatile uint8_t*)0x1C000028)
#define GPIO_B41	(*(volatile uint8_t*)0x1C000029)
#define GPIO_B42	(*(volatile uint8_t*)0x1C00002A)
#define GPIO_B43	(*(volatile uint8_t*)0x1C00002B)
#define GPIO_B44	(*(volatile uint8_t*)0x1C00002C)
#define GPIO_B45	(*(volatile uint8_t*)0x1C00002D)
#define GPIO_B46	(*(volatile uint8_t*)0x1C00002E)
#define GPIO_B47	(*(volatile uint8_t*)0x1C00002F)
#define GPIO_B48	(*(volatile uint8_t*)0x1C000030)
#define GPIO_B49	(*(volatile uint8_t*)0x1C000031)
#define GPIO_B50	(*(volatile uint8_t*)0x1C000032)
#define GPIO_B51	(*(volatile uint8_t*)0x1C000033)
#define GPIO_B52	(*(volatile uint8_t*)0x1C000034)
#define GPIO_B53	(*(volatile uint8_t*)0x1C000035)
#define GPIO_B54	(*(volatile uint8_t*)0x1C000036)
#define GPIO_B55	(*(volatile uint8_t*)0x1C000037)
#define GPIO_B56	(*(volatile uint8_t*)0x1C000038)
#define GPIO_B57	(*(volatile uint8_t*)0x1C000039)
#define GPIO_B58	(*(volatile uint8_t*)0x1C00003A)
#define GPIO_B59	(*(volatile uint8_t*)0x1C00003B)
#define GPIO_B60	(*(volatile uint8_t*)0x1C00003C)
#define GPIO_B61	(*(volatile uint8_t*)0x1C00003D)
#define GPIO_B62	(*(volatile uint8_t*)0x1C00003E)
#define GPIO_B63	(*(volatile uint8_t*)0x1C00003F)
#define GPIO_B64	(*(volatile uint8_t*)0x1C000040)
#define GPIO_B65	(*(volatile uint8_t*)0x1C000041)
#define GPIO_B66	(*(volatile uint8_t*)0x1C000042)
#define GPIO_B67	(*(volatile uint8_t*)0x1C000043)
#define GPIO_B68	(*(volatile uint8_t*)0x1C000044)
#define GPIO_B69	(*(volatile uint8_t*)0x1C000045)
#define GPIO_B70	(*(volatile uint8_t*)0x1C000046)
#define GPIO_B71	(*(volatile uint8_t*)0x1C000047)
#define GPIO_B72	(*(volatile uint8_t*)0x1C000048)
#define GPIO_B73	(*(volatile uint8_t*)0x1C000049)
#define GPIO_B74	(*(volatile uint8_t*)0x1C00004A)
#define GPIO_B75	(*(volatile uint8_t*)0x1C00004B)

#define GPIO_W		( (volatile uint32_t*)0x1C001000)
#define GPIO_W0		(*(volatile uint32_t*)0x1C001000)
#define GPIO_W1		(*(volatile uint32_t*)0x1C001004)
#define GPIO_W2		(*(volatile uint32_t*)0x1C001008)
#define GPIO_W3		(*(volatile uint32_t*)0x1C00100C)
#define GPIO_W4		(*(volatile uint32_t*)0x1C001010)
#define GPIO_W5		(*(volatile uint32_t*)0x1C001014)
#define GPIO_W6		(*(volatile uint32_t*)0x1C001018)
#define GPIO_W7		(*(volatile uint32_t*)0x1C00101C)
#define GPIO_W8		(*(volatile uint32_t*)0x1C001020)
#define GPIO_W9		(*(volatile uint32_t*)0x1C001024)
#define GPIO_W10	(*(volatile uint32_t*)0x1C001028)
#define GPIO_W11	(*(volatile uint32_t*)0x1C00102C)
#define GPIO_W12	(*(volatile uint32_t*)0x1C001030)
#define GPIO_W13	(*(volatile uint32_t*)0x1C001034)
#define GPIO_W14	(*(volatile uint32_t*)0x1C001038)
#define GPIO_W15	(*(volatile uint32_t*)0x1C00103C)
#define GPIO_W16	(*(volatile uint32_t*)0x1C001040)
#define GPIO_W17	(*(volatile uint32_t*)0x1C001044)
#define GPIO_W18	(*(volatile uint32_t*)0x1C001048)
#define GPIO_W19	(*(volatile uint32_t*)0x1C00104C)
#define GPIO_W20	(*(volatile uint32_t*)0x1C001050)
#define GPIO_W21	(*(volatile uint32_t*)0x1C001054)
#define GPIO_W22	(*(volatile uint32_t*)0x1C001058)
#define GPIO_W23	(*(volatile uint32_t*)0x1C00105C)
#define GPIO_W24	(*(volatile uint32_t*)0x1C001060)
#define GPIO_W25	(*(volatile uint32_t*)0x1C001064)
#define GPIO_W26	(*(volatile uint32_t*)0x1C001068)
#define GPIO_W27	(*(volatile uint32_t*)0x1C00106C)
#define GPIO_W28	(*(volatile uint32_t*)0x1C001070)
#define GPIO_W29	(*(volatile uint32_t*)0x1C001074)
#define GPIO_W30	(*(volatile uint32_t*)0x1C001078)
#define GPIO_W31	(*(volatile uint32_t*)0x1C00107C)
#define GPIO_W32	(*(volatile uint32_t*)0x1C001080)
#define GPIO_W33	(*(volatile uint32_t*)0x1C001084)
#define GPIO_W34	(*(volatile uint32_t*)0x1C001088)
#define GPIO_W35	(*(volatile uint32_t*)0x1C00108C)
#define GPIO_W36	(*(volatile uint32_t*)0x1C001090)
#define GPIO_W37	(*(volatile uint32_t*)0x1C001094)
#define GPIO_W38	(*(volatile uint32_t*)0x1C001098)
#define GPIO_W39	(*(volatile uint32_t*)0x1C00109C)
#define GPIO_W40	(*(volatile uint32_t*)0x1C0010A0)
#define GPIO_W41	(*(volatile uint32_t*)0x1C0010A4)
#define GPIO_W42	(*(volatile uint32_t*)0x1C0010A8)
#define GPIO_W43	(*(volatile uint32_t*)0x1C0010AC)
#define GPIO_W44	(*(volatile uint32_t*)0x1C0010B0)
#define GPIO_W45	(*(volatile uint32_t*)0x1C0010B4)
#define GPIO_W46	(*(volatile uint32_t*)0x1C0010B8)
#define GPIO_W47	(*(volatile uint32_t*)0x1C0010BC)
#define GPIO_W48	(*(volatile uint32_t*)0x1C0010C0)
#define GPIO_W49	(*(volatile uint32_t*)0x1C0010C4)
#define GPIO_W50	(*(volatile uint32_t*)0x1C0010C8)
#define GPIO_W51	(*(volatile uint32_t*)0x1C0010CC)
#define GPIO_W52	(*(volatile uint32_t*)0x1C0010D0)
#define GPIO_W53	(*(volatile uint32_t*)0x1C0010D4)
#define GPIO_W54	(*(volatile uint32_t*)0x1C0010D8)
#define GPIO_W55	(*(volatile uint32_t*)0x1C0010DC)
#define GPIO_W56	(*(volatile uint32_t*)0x1C0010E0)
#define GPIO_W57	(*(volatile uint32_t*)0x1C0010E4)
#define GPIO_W58	(*(volatile uint32_t*)0x1C0010E8)
#define GPIO_W59	(*(volatile uint32_t*)0x1C0010EC)
#define GPIO_W60	(*(volatile uint32_t*)0x1C0010F0)
#define GPIO_W61	(*(volatile uint32_t*)0x1C0010F4)
#define GPIO_W62	(*(volatile uint32_t*)0x1C0010F8)
#define GPIO_W63	(*(volatile uint32_t*)0x1C0010FC)
#define GPIO_W64	(*(volatile uint32_t*)0x1C001100)
#define GPIO_W65	(*(volatile uint32_t*)0x1C001104)
#define GPIO_W66	(*(volatile uint32_t*)0x1C001108)
#define GPIO_W67	(*(volatile uint32_t*)0x1C00110C)
#define GPIO_W68	(*(volatile uint32_t*)0x1C001110)
#define GPIO_W69	(*(volatile uint32_t*)0x1C001114)
#define GPIO_W70	(*(volatile uint32_t*)0x1C001118)
#define GPIO_W71	(*(volatile uint32_t*)0x1C00111C)
#define GPIO_W72	(*(volatile uint32_t*)0x1C001120)
#define GPIO_W73	(*(volatile uint32_t*)0x1C001124)
#define GPIO_W74	(*(volatile uint32_t*)0x1C001128)
#define GPIO_W75	(*(volatile uint32_t*)0x1C00112C)

#define GPIO_DIR0	(*(volatile uint32_t*)0x1C002000)
#define GPIO_DIR0L	(*(volatile uint16_t*)0x1C002000)
#define GPIO_DIR0H	(*(volatile uint16_t*)0x1C002002)
#define GPIO_DIR0LL	(*(volatile uint8_t*)0x1C002000)
#define GPIO_DIR0LH	(*(volatile uint8_t*)0x1C002001)
#define GPIO_DIR0HL	(*(volatile uint8_t*)0x1C002002)
#define GPIO_DIR0HH	(*(volatile uint8_t*)0x1C002003)
#define GPIO_DIR1	(*(volatile uint32_t*)0x1C002004)
#define GPIO_DIR1L	(*(volatile uint16_t*)0x1C002004)
#define GPIO_DIR1H	(*(volatile uint16_t*)0x1C002006)
#define GPIO_DIR1LL	(*(volatile uint8_t*)0x1C002004)
#define GPIO_DIR1LH	(*(volatile uint8_t*)0x1C002005)
#define GPIO_DIR1HL	(*(volatile uint8_t*)0x1C002006)
#define GPIO_DIR1HH	(*(volatile uint8_t*)0x1C002007)
#define GPIO_DIR2	(*(volatile uint32_t*)0x1C002008)
#define GPIO_DIR2L	(*(volatile uint16_t*)0x1C002008)
#define GPIO_DIR2H	(*(volatile uint16_t*)0x1C00200A)
#define GPIO_DIR2LL	(*(volatile uint8_t*)0x1C002008)
#define GPIO_DIR2LH	(*(volatile uint8_t*)0x1C002009)
#define GPIO_DIR2HL	(*(volatile uint8_t*)0x1C00200A)
#define GPIO_DIR2HH	(*(volatile uint8_t*)0x1C00200B)

#define GPIO_MASK0	(*(volatile uint32_t*)0x1C002080)
#define GPIO_MASK0L	(*(volatile uint16_t*)0x1C002080)
#define GPIO_MASK0H	(*(volatile uint16_t*)0x1C002082)
#define GPIO_MASK0LL	(*(volatile uint8_t*)0x1C002080)
#define GPIO_MASK0LH	(*(volatile uint8_t*)0x1C002081)
#define GPIO_MASK0HL	(*(volatile uint8_t*)0x1C002082)
#define GPIO_MASK0HH	(*(volatile uint8_t*)0x1C002083)
#define GPIO_MASK1	(*(volatile uint32_t*)0x1C002084)
#define GPIO_MASK1L	(*(volatile uint16_t*)0x1C002084)
#define GPIO_MASK1H	(*(volatile uint16_t*)0x1C002086)
#define GPIO_MASK1LL	(*(volatile uint8_t*)0x1C002084)
#define GPIO_MASK1LH	(*(volatile uint8_t*)0x1C002085)
#define GPIO_MASK1HL	(*(volatile uint8_t*)0x1C002086)
#define GPIO_MASK1HH	(*(volatile uint8_t*)0x1C002087)
#define GPIO_MASK2	(*(volatile uint32_t*)0x1C002088)
#define GPIO_MASK2L	(*(volatile uint16_t*)0x1C002088)
#define GPIO_MASK2H	(*(volatile uint16_t*)0x1C00208A)
#define GPIO_MASK2LL	(*(volatile uint8_t*)0x1C002088)
#define GPIO_MASK2LH	(*(volatile uint8_t*)0x1C002089)
#define GPIO_MASK2HL	(*(volatile uint8_t*)0x1C00208A)
#define GPIO_MASK2HH	(*(volatile uint8_t*)0x1C00208B)

#define GPIO_PIN0	(*(volatile uint32_t*)0x1C002100)
#define GPIO_PIN0L	(*(volatile uint16_t*)0x1C002100)
#define GPIO_PIN0H	(*(volatile uint16_t*)0x1C002102)
#define GPIO_PIN0LL	(*(volatile uint8_t*)0x1C002100)
#define GPIO_PIN0LH	(*(volatile uint8_t*)0x1C002101)
#define GPIO_PIN0HL	(*(volatile uint8_t*)0x1C002102)
#define GPIO_PIN0HH	(*(volatile uint8_t*)0x1C002103)
#define GPIO_PIN1	(*(volatile uint32_t*)0x1C002104)
#define GPIO_PIN1L	(*(volatile uint16_t*)0x1C002104)
#define GPIO_PIN1H	(*(volatile uint16_t*)0x1C002106)
#define GPIO_PIN1LL	(*(volatile uint8_t*)0x1C002104)
#define GPIO_PIN1LH	(*(volatile uint8_t*)0x1C002105)
#define GPIO_PIN1HL	(*(volatile uint8_t*)0x1C002106)
#define GPIO_PIN1HH	(*(volatile uint8_t*)0x1C002107)
#define GPIO_PIN2	(*(volatile uint32_t*)0x1C002108)
#define GPIO_PIN2L	(*(volatile uint16_t*)0x1C002108)
#define GPIO_PIN2H	(*(volatile uint16_t*)0x1C00210A)
#define GPIO_PIN2LL	(*(volatile uint8_t*)0x1C002108)
#define GPIO_PIN2LH	(*(volatile uint8_t*)0x1C002109)
#define GPIO_PIN2HL	(*(volatile uint8_t*)0x1C00210A)
#define GPIO_PIN2HH	(*(volatile uint8_t*)0x1C00210B)

#define GPIO_MPIN0	(*(volatile uint32_t*)0x1C002180)
#define GPIO_MPIN0L	(*(volatile uint16_t*)0x1C002180)
#define GPIO_MPIN0H	(*(volatile uint16_t*)0x1C002182)
#define GPIO_MPIN0LL	(*(volatile uint8_t*)0x1C002180)
#define GPIO_MPIN0LH	(*(volatile uint8_t*)0x1C002181)
#define GPIO_MPIN0HL	(*(volatile uint8_t*)0x1C002182)
#define GPIO_MPIN0HH	(*(volatile uint8_t*)0x1C002183)
#define GPIO_MPIN1	(*(volatile uint32_t*)0x1C002184)
#define GPIO_MPIN1L	(*(volatile uint16_t*)0x1C002184)
#define GPIO_MPIN1H	(*(volatile uint16_t*)0x1C002186)
#define GPIO_MPIN1LL	(*(volatile uint8_t*)0x1C002184)
#define GPIO_MPIN1LH	(*(volatile uint8_t*)0x1C002185)
#define GPIO_MPIN1HL	(*(volatile uint8_t*)0x1C002186)
#define GPIO_MPIN1HH	(*(volatile uint8_t*)0x1C002187)
#define GPIO_MPIN2	(*(volatile uint32_t*)0x1C002188)
#define GPIO_MPIN2L	(*(volatile uint16_t*)0x1C002188)
#define GPIO_MPIN2H	(*(volatile uint16_t*)0x1C00218A)
#define GPIO_MPIN2LL	(*(volatile uint8_t*)0x1C002188)
#define GPIO_MPIN2LH	(*(volatile uint8_t*)0x1C002189)
#define GPIO_MPIN2HL	(*(volatile uint8_t*)0x1C00218A)
#define GPIO_MPIN2HH	(*(volatile uint8_t*)0x1C00218B)

#define GPIO_SET0	(*(volatile uint32_t*)0x1C002200)
#define GPIO_SET0L	(*(volatile uint16_t*)0x1C002200)
#define GPIO_SET0H	(*(volatile uint16_t*)0x1C002202)
#define GPIO_SET0LL	(*(volatile uint8_t*)0x1C002200)
#define GPIO_SET0LH	(*(volatile uint8_t*)0x1C002201)
#define GPIO_SET0HL	(*(volatile uint8_t*)0x1C002202)
#define GPIO_SET0HH	(*(volatile uint8_t*)0x1C002203)
#define GPIO_SET1	(*(volatile uint32_t*)0x1C002204)
#define GPIO_SET1	(*(volatile uint16_t*)0x1C002204)
#define GPIO_SET1	(*(volatile uint16_t*)0x1C002206)
#define GPIO_SET1LL	(*(volatile uint8_t*)0x1C002204)
#define GPIO_SET1LH	(*(volatile uint8_t*)0x1C002205)
#define GPIO_SET1HL	(*(volatile uint8_t*)0x1C002206)
#define GPIO_SET1HH	(*(volatile uint8_t*)0x1C002207)
#define GPIO_SET2	(*(volatile uint32_t*)0x1C002208)
#define GPIO_SET2L	(*(volatile uint16_t*)0x1C002208)
#define GPIO_SET2H	(*(volatile uint16_t*)0x1C00220A)
#define GPIO_SET2LL	(*(volatile uint8_t*)0x1C002208)
#define GPIO_SET2LH	(*(volatile uint8_t*)0x1C002209)
#define GPIO_SET2HL	(*(volatile uint8_t*)0x1C00220A)
#define GPIO_SET2HH	(*(volatile uint8_t*)0x1C00220B)

#define GPIO_CLR0	(*(volatile uint32_t*)0x1C002280)
#define GPIO_CLR0L	(*(volatile uint16_t*)0x1C002280)
#define GPIO_CLR0H	(*(volatile uint16_t*)0x1C002282)
#define GPIO_CLR0LL	(*(volatile uint8_t*)0x1C002280)
#define GPIO_CLR0LH	(*(volatile uint8_t*)0x1C002281)
#define GPIO_CLR0HL	(*(volatile uint8_t*)0x1C002282)
#define GPIO_CLR0HH	(*(volatile uint8_t*)0x1C002283)
#define GPIO_CLR1	(*(volatile uint32_t*)0x1C002284)
#define GPIO_CLR1L	(*(volatile uint16_t*)0x1C002284)
#define GPIO_CLR1H	(*(volatile uint16_t*)0x1C002286)
#define GPIO_CLR1LL	(*(volatile uint8_t*)0x1C002284)
#define GPIO_CLR1LH	(*(volatile uint8_t*)0x1C002285)
#define GPIO_CLR1HL	(*(volatile uint8_t*)0x1C002286)
#define GPIO_CLR1HH	(*(volatile uint8_t*)0x1C002287)
#define GPIO_CLR2	(*(volatile uint32_t*)0x1C002288)
#define GPIO_CLR2L	(*(volatile uint16_t*)0x1C002288)
#define GPIO_CLR2H	(*(volatile uint16_t*)0x1C00228A)
#define GPIO_CLR2LL	(*(volatile uint8_t*)0x1C002288)
#define GPIO_CLR2LH	(*(volatile uint8_t*)0x1C002289)
#define GPIO_CLR2HL	(*(volatile uint8_t*)0x1C00228A)
#define GPIO_CLR2HH	(*(volatile uint8_t*)0x1C00228B)

#define GPIO_NOT0	(*(volatile uint32_t*)0x1C002300)
#define GPIO_NOT0L	(*(volatile uint16_t*)0x1C002300)
#define GPIO_NOT0H	(*(volatile uint16_t*)0x1C002302)
#define GPIO_NOT0LL	(*(volatile uint8_t*)0x1C002300)
#define GPIO_NOT0LH	(*(volatile uint8_t*)0x1C002301)
#define GPIO_NOT0HL	(*(volatile uint8_t*)0x1C002302)
#define GPIO_NOT0HH	(*(volatile uint8_t*)0x1C0023003)
#define GPIO_NOT1	(*(volatile uint32_t*)0x1C002304)
#define GPIO_NOT1L	(*(volatile uint16_t*)0x1C002304)
#define GPIO_NOT1H	(*(volatile uint16_t*)0x1C002306)
#define GPIO_NOT1LL	(*(volatile uint8_t*)0x1C002304)
#define GPIO_NOT1LH	(*(volatile uint8_t*)0x1C002305)
#define GPIO_NOT1HL	(*(volatile uint8_t*)0x1C002306)
#define GPIO_NOT1HH	(*(volatile uint8_t*)0x1C002307)
#define GPIO_NOT2	(*(volatile uint32_t*)0x1C002308)
#define GPIO_NOT2L	(*(volatile uint16_t*)0x1C002308)
#define GPIO_NOT2H	(*(volatile uint16_t*)0x1C00230A)
#define GPIO_NOT2LL	(*(volatile uint8_t*)0x1C002308)
#define GPIO_NOT2LH	(*(volatile uint8_t*)0x1C002309)
#define GPIO_NOT2HL	(*(volatile uint8_t*)0x1C00230A)
#define GPIO_NOT2HH	(*(volatile uint8_t*)0x1C00230B)

/* GINT0, GINT1 */
#define GINT0_CTRL		(*(volatile uint32_t*)0x400A8000)
#define GINT0_PORT_POL0	(*(volatile uint32_t*)0x400A8020)
#define GINT0_PORT_POL1	(*(volatile uint32_t*)0x400A8024)
#define GINT0_PORT_POL2	(*(volatile uint32_t*)0x400A8028)
#define GINT0_PORT_ENA0	(*(volatile uint32_t*)0x400A8040)
#define GINT0_PORT_ENA1	(*(volatile uint32_t*)0x400A8044)
#define GINT0_PORT_ENA2	(*(volatile uint32_t*)0x400A8048)
#define GINT1_CTRL		(*(volatile uint32_t*)0x400AC000)
#define GINT1_PORT_POL0	(*(volatile uint32_t*)0x400AC020)
#define GINT1_PORT_POL1	(*(volatile uint32_t*)0x400AC024)
#define GINT1_PORT_POL2	(*(volatile uint32_t*)0x400AC028)
#define GINT1_PORT_ENA0	(*(volatile uint32_t*)0x400AC040)
#define GINT1_PORT_ENA1	(*(volatile uint32_t*)0x400AC044)
#define GINT1_PORT_ENA2	(*(volatile uint32_t*)0x400AC048)

/* PINT */
#define PINT_ISEL		(*(volatile uint32_t*)0x400A4000)
#define PINT_IENR		(*(volatile uint32_t*)0x400A4004)
#define PINT_SIENR		(*(volatile uint32_t*)0x400A4008)
#define PINT_CIENR		(*(volatile uint32_t*)0x400A400C)
#define PINT_IENF		(*(volatile uint32_t*)0x400A4010)
#define PINT_SIENF		(*(volatile uint32_t*)0x400A4014)
#define PINT_CIENF		(*(volatile uint32_t*)0x400A4018)
#define PINT_RISE		(*(volatile uint32_t*)0x400A401C)
#define PINT_FALL		(*(volatile uint32_t*)0x400A4020)
#define PINT_IST		(*(volatile uint32_t*)0x400A4024)
#define PINT_PMCTRL		(*(volatile uint32_t*)0x400A4028)
#define PINT_PMSRC		(*(volatile uint32_t*)0x400A402C)
#define PINT_PMCFG		(*(volatile uint32_t*)0x400A4030)

/* DMA */
#define DMA_CTRL		(*(volatile uint32_t*)0x1C004000)
#define DMA_INTSTAT		(*(volatile uint32_t*)0x1C004004)
#define DMA_SRAMBASE	(*(volatile uint32_t*)0x1C004008)
#define DMA_ENABLESET0	(*(volatile uint32_t*)0x1C004020)
#define DMA_ENABLECLR0	(*(volatile uint32_t*)0x1C004028)
#define DMA_ACTIVE0		(*(volatile uint32_t*)0x1C004030)
#define DMA_BUSY0		(*(volatile uint32_t*)0x1C004038)
#define DMA_ERRINT0		(*(volatile uint32_t*)0x1C004040)
#define DMA_INTENSET0	(*(volatile uint32_t*)0x1C004048)
#define DMA_INTENCLR0	(*(volatile uint32_t*)0x1C004050)
#define DMA_INTA0		(*(volatile uint32_t*)0x1C004058)
#define DMA_INTB0		(*(volatile uint32_t*)0x1C004060)
#define DMA_SETVALID0	(*(volatile uint32_t*)0x1C004068)
#define DMA_SETTRIG0	(*(volatile uint32_t*)0x1C004070)
#define DMA_ABORT0		(*(volatile uint32_t*)0x1C004078)
#define DMA_CFG0		(*(volatile uint32_t*)0x1C004400)
#define DMA_CTLSTAT0	(*(volatile uint32_t*)0x1C004404)
#define DMA_XFERCFG0	(*(volatile uint32_t*)0x1C004408)
#define DMA_CFG1		(*(volatile uint32_t*)0x1C004410)
#define DMA_CTLSTAT1	(*(volatile uint32_t*)0x1C004414)
#define DMA_XFERCFG1	(*(volatile uint32_t*)0x1C004418)
#define DMA_CFG2		(*(volatile uint32_t*)0x1C004420)
#define DMA_CTLSTAT2	(*(volatile uint32_t*)0x1C004424)
#define DMA_XFERCFG2	(*(volatile uint32_t*)0x1C004428)
#define DMA_CFG3		(*(volatile uint32_t*)0x1C004430)
#define DMA_CTLSTAT3	(*(volatile uint32_t*)0x1C004434)
#define DMA_XFERCFG3	(*(volatile uint32_t*)0x1C004438)
#define DMA_CFG4		(*(volatile uint32_t*)0x1C004440)
#define DMA_CTLSTAT4	(*(volatile uint32_t*)0x1C004444)
#define DMA_XFERCFG4	(*(volatile uint32_t*)0x1C004448)
#define DMA_CFG5		(*(volatile uint32_t*)0x1C004450)
#define DMA_CTLSTAT5	(*(volatile uint32_t*)0x1C004454)
#define DMA_XFERCFG5	(*(volatile uint32_t*)0x1C004458)
#define DMA_CFG6		(*(volatile uint32_t*)0x1C004460)
#define DMA_CTLSTAT6	(*(volatile uint32_t*)0x1C004464)
#define DMA_XFERCFG6	(*(volatile uint32_t*)0x1C004468)
#define DMA_CFG7		(*(volatile uint32_t*)0x1C004470)
#define DMA_CTLSTAT7	(*(volatile uint32_t*)0x1C004474)
#define DMA_XFERCFG7	(*(volatile uint32_t*)0x1C004478)
#define DMA_CFG8		(*(volatile uint32_t*)0x1C004480)
#define DMA_CTLSTAT8	(*(volatile uint32_t*)0x1C004484)
#define DMA_XFERCFG8	(*(volatile uint32_t*)0x1C004488)
#define DMA_CFG9		(*(volatile uint32_t*)0x1C004490)
#define DMA_CTLSTAT9	(*(volatile uint32_t*)0x1C004494)
#define DMA_XFERCFG9	(*(volatile uint32_t*)0x1C004498)
#define DMA_CFG10		(*(volatile uint32_t*)0x1C0044A0)
#define DMA_CTLSTAT10	(*(volatile uint32_t*)0x1C0044A4)
#define DMA_XFERCFG10	(*(volatile uint32_t*)0x1C0044A8)
#define DMA_CFG11		(*(volatile uint32_t*)0x1C0044B0)
#define DMA_CTLSTAT11	(*(volatile uint32_t*)0x1C0044B4)
#define DMA_XFERCFG11	(*(volatile uint32_t*)0x1C0044B8)
#define DMA_CFG12		(*(volatile uint32_t*)0x1C0044C0)
#define DMA_CTLSTAT12	(*(volatile uint32_t*)0x1C0044C4)
#define DMA_XFERCFG12	(*(volatile uint32_t*)0x1C0044C8)
#define DMA_CFG13		(*(volatile uint32_t*)0x1C0044D0)
#define DMA_CTLSTAT13	(*(volatile uint32_t*)0x1C0044D4)
#define DMA_XFERCFG13	(*(volatile uint32_t*)0x1C0044D8)
#define DMA_CFG14		(*(volatile uint32_t*)0x1C0044E0)
#define DMA_CTLSTAT14	(*(volatile uint32_t*)0x1C0044E4)
#define DMA_XFERCFG14	(*(volatile uint32_t*)0x1C0044E8)
#define DMA_CFG15		(*(volatile uint32_t*)0x1C0044F0)
#define DMA_CTLSTAT15	(*(volatile uint32_t*)0x1C0044F4)
#define DMA_XFERCFG15	(*(volatile uint32_t*)0x1C0044F8)
#define DMA_CFG16		(*(volatile uint32_t*)0x1C004500)
#define DMA_CTLSTAT16	(*(volatile uint32_t*)0x1C004504)
#define DMA_XFERCFG16	(*(volatile uint32_t*)0x1C004508)
#define DMA_CFG17		(*(volatile uint32_t*)0x1C004510)
#define DMA_CTLSTAT17	(*(volatile uint32_t*)0x1C004514)
#define DMA_XFERCFG17	(*(volatile uint32_t*)0x1C004518)

/* SCTIPU */
#define SAMPLE_CTRL		(*(volatile uint32_t*)0x400B8000)
#define ABORT_ENABLE0	(*(volatile uint32_t*)0x400B8020)
#define ABORT_SOURCE0	(*(volatile uint32_t*)0x400B8024)
#define ABORT_ENABLE1	(*(volatile uint32_t*)0x400B8040)
#define ABORT_SOURCE1	(*(volatile uint32_t*)0x400B8044)
#define ABORT_ENABLE2	(*(volatile uint32_t*)0x400B8060)
#define ABORT_SOURCE2	(*(volatile uint32_t*)0x400B8064)
#define ABORT_ENABLE3	(*(volatile uint32_t*)0x400B8080)
#define ABORT_SOURCE3	(*(volatile uint32_t*)0x400B8084)

/* SCT0, SCT1 */
#define SCT0_CONFIG			(*(volatile uint32_t*)0x1C018000)
#define SCT0_CTRL			(*(volatile uint32_t*)0x1C018004)
#define SCT0_CTRL_L			(*(volatile uint16_t*)0x1C018004)
#define SCT0_CTRL_H			(*(volatile uint16_t*)0x1C018006)
#define SCT0_LIMIT			(*(volatile uint32_t*)0x1C018008)
#define SCT0_LIMIT_L		(*(volatile uint16_t*)0x1C018008)
#define SCT0_LIMIT_H		(*(volatile uint16_t*)0x1C01800A)
#define SCT0_HALT			(*(volatile uint32_t*)0x1C01800C)
#define SCT0_HALT_L			(*(volatile uint16_t*)0x1C01800C)
#define SCT0_HALT_H			(*(volatile uint16_t*)0x1C01800E)
#define SCT0_STOP			(*(volatile uint32_t*)0x1C018010)
#define SCT0_STOP_L			(*(volatile uint16_t*)0x1C018010)
#define SCT0_STOP_H			(*(volatile uint16_t*)0x1C018012)
#define SCT0_START			(*(volatile uint32_t*)0x1C018014)
#define SCT0_START_L		(*(volatile uint16_t*)0x1C018014)
#define SCT0_START_H		(*(volatile uint16_t*)0x1C018016)
#define SCT0_DITHER			(*(volatile uint32_t*)0x1C018018)
#define SCT0_DITHER_L		(*(volatile uint16_t*)0x1C018018)
#define SCT0_DITHER_H		(*(volatile uint16_t*)0x1C01801A)
#define SCT0_COUNT			(*(volatile uint32_t*)0x1C018040)
#define SCT0_COUNT_L		(*(volatile uint16_t*)0x1C018040)
#define SCT0_COUNT_H		(*(volatile uint16_t*)0x1C018042)
#define SCT0_STATE			(*(volatile uint32_t*)0x1C018044)
#define SCT0_STALE_L		(*(volatile uint16_t*)0x1C018044)
#define SCT0_STALE_H		(*(volatile uint16_t*)0x1C018046)
#define SCT0_INPUT			(*(volatile uint32_t*)0x1C018048)
#define SCT0_REGMODE		(*(volatile uint32_t*)0x1C01804C)
#define SCT0_REGMODE_L		(*(volatile uint32_t*)0x1C01804C)
#define SCT0_REGMODE_H		(*(volatile uint32_t*)0x1C01804E)
#define SCT0_OUTPUT			(*(volatile uint32_t*)0x1C018050)
#define SCT0_OUTPUTDIRCTRL	(*(volatile uint32_t*)0x1C018054)
#define SCT0_RES			(*(volatile uint32_t*)0x1C018058)
#define SCT0_DMAREQ0		(*(volatile uint32_t*)0x1C01805C)
#define SCT0_DMAREQ1		(*(volatile uint32_t*)0x1C018060)
#define SCT0_EVEN			(*(volatile uint32_t*)0x1C0180F0)
#define SCT0_EVFLAG			(*(volatile uint32_t*)0x1C0180F4)
#define SCT0_CONEN			(*(volatile uint32_t*)0x1C0180F8)
#define SCT0_CONFLAG		(*(volatile uint32_t*)0x1C0180FC)
#define SCT0_MATCH0			(*(volatile uint32_t*)0x1C018100)
#define SCT0_MATCH1			(*(volatile uint32_t*)0x1C018104)
#define SCT0_MATCH2			(*(volatile uint32_t*)0x1C018108)
#define SCT0_MATCH3			(*(volatile uint32_t*)0x1C01810C)
#define SCT0_MATCH4			(*(volatile uint32_t*)0x1C018110)
#define SCT0_MATCH5			(*(volatile uint32_t*)0x1C018114)
#define SCT0_MATCH6			(*(volatile uint32_t*)0x1C018118)
#define SCT0_MATCH7			(*(volatile uint32_t*)0x1C01811C)
#define SCT0_MATCH8			(*(volatile uint32_t*)0x1C018120)
#define SCT0_MATCH9			(*(volatile uint32_t*)0x1C018124)
#define SCT0_MATCH10		(*(volatile uint32_t*)0x1C018128)
#define SCT0_MATCH11		(*(volatile uint32_t*)0x1C01812C)
#define SCT0_MATCH12		(*(volatile uint32_t*)0x1C018130)
#define SCT0_MATCH13		(*(volatile uint32_t*)0x1C018134)
#define SCT0_MATCH14		(*(volatile uint32_t*)0x1C018138)
#define SCT0_MATCH15		(*(volatile uint32_t*)0x1C01813C)
#define SCT0_MATCH0_L		(*(volatile uint16_t*)0x1C018100)
#define SCT0_MATCH1_L		(*(volatile uint16_t*)0x1C018104)
#define SCT0_MATCH2_L		(*(volatile uint16_t*)0x1C018108)
#define SCT0_MATCH3_L		(*(volatile uint16_t*)0x1C01810C)
#define SCT0_MATCH4_L		(*(volatile uint16_t*)0x1C018110)
#define SCT0_MATCH5_L		(*(volatile uint16_t*)0x1C018114)
#define SCT0_MATCH6_L		(*(volatile uint16_t*)0x1C018118)
#define SCT0_MATCH7_L		(*(volatile uint16_t*)0x1C01811C)
#define SCT0_MATCH8_L		(*(volatile uint16_t*)0x1C018120)
#define SCT0_MATCH9_L		(*(volatile uint16_t*)0x1C018124)
#define SCT0_MATCH10_L		(*(volatile uint16_t*)0x1C018128)
#define SCT0_MATCH11_L		(*(volatile uint16_t*)0x1C01812C)
#define SCT0_MATCH12_L		(*(volatile uint16_t*)0x1C018130)
#define SCT0_MATCH13_L		(*(volatile uint16_t*)0x1C018134)
#define SCT0_MATCH14_L		(*(volatile uint16_t*)0x1C018138)
#define SCT0_MATCH15_L		(*(volatile uint16_t*)0x1C01813C)
#define SCT0_MATCH0_H		(*(volatile uint16_t*)0x1C018100)
#define SCT0_MATCH1_H		(*(volatile uint16_t*)0x1C018104)
#define SCT0_MATCH2_H		(*(volatile uint16_t*)0x1C018108)
#define SCT0_MATCH3_H		(*(volatile uint16_t*)0x1C01810C)
#define SCT0_MATCH4_H		(*(volatile uint16_t*)0x1C018110)
#define SCT0_MATCH5_H		(*(volatile uint16_t*)0x1C018114)
#define SCT0_MATCH6_H		(*(volatile uint16_t*)0x1C018118)
#define SCT0_MATCH7_H		(*(volatile uint16_t*)0x1C01811C)
#define SCT0_MATCH8_H		(*(volatile uint16_t*)0x1C018120)
#define SCT0_MATCH9_H		(*(volatile uint16_t*)0x1C018124)
#define SCT0_MATCH10_H		(*(volatile uint16_t*)0x1C018128)
#define SCT0_MATCH11_H		(*(volatile uint16_t*)0x1C01812C)
#define SCT0_MATCH12_H		(*(volatile uint16_t*)0x1C018130)
#define SCT0_MATCH13_H		(*(volatile uint16_t*)0x1C018134)
#define SCT0_MATCH14_H		(*(volatile uint16_t*)0x1C018138)
#define SCT0_MATCH15_H		(*(volatile uint16_t*)0x1C01813C)
#define SCT0_CAP0			(*(volatile uint32_t*)0x1C018100)
#define SCT0_CAP1			(*(volatile uint32_t*)0x1C018104)
#define SCT0_CAP2			(*(volatile uint32_t*)0x1C018108)
#define SCT0_CAP3			(*(volatile uint32_t*)0x1C01810C)
#define SCT0_CAP4			(*(volatile uint32_t*)0x1C018110)
#define SCT0_CAP5			(*(volatile uint32_t*)0x1C018114)
#define SCT0_CAP6			(*(volatile uint32_t*)0x1C018118)
#define SCT0_CAP7			(*(volatile uint32_t*)0x1C01811C)
#define SCT0_CAP8			(*(volatile uint32_t*)0x1C018120)
#define SCT0_CAP9			(*(volatile uint32_t*)0x1C018124)
#define SCT0_CAP10			(*(volatile uint32_t*)0x1C018128)
#define SCT0_CAP11			(*(volatile uint32_t*)0x1C01812C)
#define SCT0_CAP12			(*(volatile uint32_t*)0x1C018130)
#define SCT0_CAP13			(*(volatile uint32_t*)0x1C018134)
#define SCT0_CAP14			(*(volatile uint32_t*)0x1C018138)
#define SCT0_CAP15			(*(volatile uint32_t*)0x1C01813C)
#define SCT0_CAP0_L			(*(volatile uint16_t*)0x1C018100)
#define SCT0_CAP1_L			(*(volatile uint16_t*)0x1C018104)
#define SCT0_CAP2_L			(*(volatile uint16_t*)0x1C018108)
#define SCT0_CAP3_L			(*(volatile uint16_t*)0x1C01810C)
#define SCT0_CAP4_L			(*(volatile uint16_t*)0x1C018110)
#define SCT0_CAP5_L			(*(volatile uint16_t*)0x1C018114)
#define SCT0_CAP6_L			(*(volatile uint16_t*)0x1C018118)
#define SCT0_CAP7_L			(*(volatile uint16_t*)0x1C01811C)
#define SCT0_CAP8_L			(*(volatile uint16_t*)0x1C018120)
#define SCT0_CAP9_L			(*(volatile uint16_t*)0x1C018124)
#define SCT0_CAP10_L		(*(volatile uint16_t*)0x1C018128)
#define SCT0_CAP11_L		(*(volatile uint16_t*)0x1C01812C)
#define SCT0_CAP12_L		(*(volatile uint16_t*)0x1C018130)
#define SCT0_CAP13_L		(*(volatile uint16_t*)0x1C018134)
#define SCT0_CAP14_L		(*(volatile uint16_t*)0x1C018138)
#define SCT0_CAP15_L		(*(volatile uint16_t*)0x1C01813C)
#define SCT0_CAP0_H			(*(volatile uint16_t*)0x1C018100)
#define SCT0_CAP1_H			(*(volatile uint16_t*)0x1C018104)
#define SCT0_CAP2_H			(*(volatile uint16_t*)0x1C018108)
#define SCT0_CAP3_H			(*(volatile uint16_t*)0x1C01810C)
#define SCT0_CAP4_H			(*(volatile uint16_t*)0x1C018110)
#define SCT0_CAP5_H			(*(volatile uint16_t*)0x1C018114)
#define SCT0_CAP6_H			(*(volatile uint16_t*)0x1C018118)
#define SCT0_CAP7_H			(*(volatile uint16_t*)0x1C01811C)
#define SCT0_CAP8_H			(*(volatile uint16_t*)0x1C018120)
#define SCT0_CAP9_H			(*(volatile uint16_t*)0x1C018124)
#define SCT0_CAP10_H		(*(volatile uint16_t*)0x1C018128)
#define SCT0_CAP11_H		(*(volatile uint16_t*)0x1C01812C)
#define SCT0_CAP12_H		(*(volatile uint16_t*)0x1C018130)
#define SCT0_CAP13_H		(*(volatile uint16_t*)0x1C018134)
#define SCT0_CAP14_H		(*(volatile uint16_t*)0x1C018138)
#define SCT0_CAP15_H		(*(volatile uint16_t*)0x1C01813C)
#define SCT0_FRACMAT0		(*(volatile uint32_t*)0x1C018140)
#define SCT0_FRACMAT1		(*(volatile uint32_t*)0x1C018144)
#define SCT0_FRACMAT2		(*(volatile uint32_t*)0x1C018148)
#define SCT0_FRACMAT3		(*(volatile uint32_t*)0x1C01814C)
#define SCT0_FRACMAT4		(*(volatile uint32_t*)0x1C018150)
#define SCT0_FRACMAT5		(*(volatile uint32_t*)0x1C018154)
#define SCT0_FRACMAT0_L		(*(volatile uint16_t*)0x1C018140)
#define SCT0_FRACMAT1_L		(*(volatile uint16_t*)0x1C018144)
#define SCT0_FRACMAT2_L		(*(volatile uint16_t*)0x1C018148)
#define SCT0_FRACMAT3_L		(*(volatile uint16_t*)0x1C01814C)
#define SCT0_FRACMAT4_L		(*(volatile uint16_t*)0x1C018150)
#define SCT0_FRACMAT5_L		(*(volatile uint16_t*)0x1C018154)
#define SCT0_FRACMAT0_H		(*(volatile uint16_t*)0x1C018142)
#define SCT0_FRACMAT1_H		(*(volatile uint16_t*)0x1C018146)
#define SCT0_FRACMAT2_H		(*(volatile uint16_t*)0x1C01814A)
#define SCT0_FRACMAT3_H		(*(volatile uint16_t*)0x1C01814E)
#define SCT0_FRACMAT4_H		(*(volatile uint16_t*)0x1C018152)
#define SCT0_FRACMAT5_H		(*(volatile uint16_t*)0x1C018156)
#define SCT0_MATCHREL0		(*(volatile uint32_t*)0x1C018200)
#define SCT0_MATCHREL1		(*(volatile uint32_t*)0x1C018204)
#define SCT0_MATCHREL2		(*(volatile uint32_t*)0x1C018208)
#define SCT0_MATCHREL3		(*(volatile uint32_t*)0x1C01820C)
#define SCT0_MATCHREL4		(*(volatile uint32_t*)0x1C018210)
#define SCT0_MATCHREL5		(*(volatile uint32_t*)0x1C018214)
#define SCT0_MATCHREL6		(*(volatile uint32_t*)0x1C018218)
#define SCT0_MATCHREL7		(*(volatile uint32_t*)0x1C01821C)
#define SCT0_MATCHREL8		(*(volatile uint32_t*)0x1C018220)
#define SCT0_MATCHREL9		(*(volatile uint32_t*)0x1C018224)
#define SCT0_MATCHREL10		(*(volatile uint32_t*)0x1C018228)
#define SCT0_MATCHREL11		(*(volatile uint32_t*)0x1C01822C)
#define SCT0_MATCHREL12		(*(volatile uint32_t*)0x1C018230)
#define SCT0_MATCHREL13		(*(volatile uint32_t*)0x1C018234)
#define SCT0_MATCHREL14		(*(volatile uint32_t*)0x1C018238)
#define SCT0_MATCHREL15		(*(volatile uint32_t*)0x1C01823C)
#define SCT0_MATCHREL0_L	(*(volatile uint16_t*)0x1C018200)
#define SCT0_MATCHREL1_L	(*(volatile uint16_t*)0x1C018204)
#define SCT0_MATCHREL2_L	(*(volatile uint16_t*)0x1C018208)
#define SCT0_MATCHREL3_L	(*(volatile uint16_t*)0x1C01820C)
#define SCT0_MATCHREL4_L	(*(volatile uint16_t*)0x1C018210)
#define SCT0_MATCHREL5_L	(*(volatile uint16_t*)0x1C018214)
#define SCT0_MATCHREL6_L	(*(volatile uint16_t*)0x1C018218)
#define SCT0_MATCHREL7_L	(*(volatile uint16_t*)0x1C01821C)
#define SCT0_MATCHREL8_L	(*(volatile uint16_t*)0x1C018220)
#define SCT0_MATCHREL9_L	(*(volatile uint16_t*)0x1C018224)
#define SCT0_MATCHREL10_L	(*(volatile uint16_t*)0x1C018228)
#define SCT0_MATCHREL11_L	(*(volatile uint16_t*)0x1C01822C)
#define SCT0_MATCHREL12_L	(*(volatile uint16_t*)0x1C018230)
#define SCT0_MATCHREL13_L	(*(volatile uint16_t*)0x1C018234)
#define SCT0_MATCHREL14_L	(*(volatile uint16_t*)0x1C018238)
#define SCT0_MATCHREL15_L	(*(volatile uint16_t*)0x1C01823C)
#define SCT0_MATCHREL0_H	(*(volatile uint16_t*)0x1C018202)
#define SCT0_MATCHREL1_H	(*(volatile uint16_t*)0x1C018206)
#define SCT0_MATCHREL2_H	(*(volatile uint16_t*)0x1C01820A)
#define SCT0_MATCHREL3_H	(*(volatile uint16_t*)0x1C01820E)
#define SCT0_MATCHREL4_H	(*(volatile uint16_t*)0x1C018212)
#define SCT0_MATCHREL5_H	(*(volatile uint16_t*)0x1C018216)
#define SCT0_MATCHREL6_H	(*(volatile uint16_t*)0x1C01821A)
#define SCT0_MATCHREL7_H	(*(volatile uint16_t*)0x1C01821E)
#define SCT0_MATCHREL8_H	(*(volatile uint16_t*)0x1C018222)
#define SCT0_MATCHREL9_H	(*(volatile uint16_t*)0x1C018226)
#define SCT0_MATCHREL10_H	(*(volatile uint16_t*)0x1C01822A)
#define SCT0_MATCHREL11_H	(*(volatile uint16_t*)0x1C01822E)
#define SCT0_MATCHREL12_H	(*(volatile uint16_t*)0x1C018232)
#define SCT0_MATCHREL13_H	(*(volatile uint16_t*)0x1C018236)
#define SCT0_MATCHREL14_H	(*(volatile uint16_t*)0x1C01823A)
#define SCT0_MATCHREL15_H	(*(volatile uint16_t*)0x1C01823E)
#define SCT0_CAPCTRL0		(*(volatile uint32_t*)0x1C018200)
#define SCT0_CAPCTRL1		(*(volatile uint32_t*)0x1C018204)
#define SCT0_CAPCTRL2		(*(volatile uint32_t*)0x1C018208)
#define SCT0_CAPCTRL3		(*(volatile uint32_t*)0x1C01820C)
#define SCT0_CAPCTRL4		(*(volatile uint32_t*)0x1C018210)
#define SCT0_CAPCTRL5		(*(volatile uint32_t*)0x1C018214)
#define SCT0_CAPCTRL6		(*(volatile uint32_t*)0x1C018218)
#define SCT0_CAPCTRL7		(*(volatile uint32_t*)0x1C01821C)
#define SCT0_CAPCTRL8		(*(volatile uint32_t*)0x1C018220)
#define SCT0_CAPCTRL9		(*(volatile uint32_t*)0x1C018224)
#define SCT0_CAPCTRL10		(*(volatile uint32_t*)0x1C018228)
#define SCT0_CAPCTRL11		(*(volatile uint32_t*)0x1C01822C)
#define SCT0_CAPCTRL12		(*(volatile uint32_t*)0x1C018230)
#define SCT0_CAPCTRL13		(*(volatile uint32_t*)0x1C018234)
#define SCT0_CAPCTRL14		(*(volatile uint32_t*)0x1C018238)
#define SCT0_CAPCTRL15		(*(volatile uint32_t*)0x1C01823C)
#define SCT0_CAPCTRL0_L		(*(volatile uint16_t*)0x1C018200)
#define SCT0_CAPCTRL1_L		(*(volatile uint16_t*)0x1C018204)
#define SCT0_CAPCTRL2_L		(*(volatile uint16_t*)0x1C018208)
#define SCT0_CAPCTRL3_L		(*(volatile uint16_t*)0x1C01820C)
#define SCT0_CAPCTRL4_L		(*(volatile uint16_t*)0x1C018210)
#define SCT0_CAPCTRL5_L		(*(volatile uint16_t*)0x1C018214)
#define SCT0_CAPCTRL6_L		(*(volatile uint16_t*)0x1C018218)
#define SCT0_CAPCTRL7_L		(*(volatile uint16_t*)0x1C01821C)
#define SCT0_CAPCTRL8_L		(*(volatile uint16_t*)0x1C018220)
#define SCT0_CAPCTRL9_L		(*(volatile uint16_t*)0x1C018224)
#define SCT0_CAPCTRL10_L	(*(volatile uint16_t*)0x1C018228)
#define SCT0_CAPCTRL11_L	(*(volatile uint16_t*)0x1C01822C)
#define SCT0_CAPCTRL12_L	(*(volatile uint16_t*)0x1C018230)
#define SCT0_CAPCTRL13_L	(*(volatile uint16_t*)0x1C018234)
#define SCT0_CAPCTRL14_L	(*(volatile uint16_t*)0x1C018238)
#define SCT0_CAPCTRL15_L	(*(volatile uint16_t*)0x1C01823C)
#define SCT0_CAPCTRL0_H		(*(volatile uint16_t*)0x1C018202)
#define SCT0_CAPCTRL1_H		(*(volatile uint16_t*)0x1C018206)
#define SCT0_CAPCTRL2_H		(*(volatile uint16_t*)0x1C01820A)
#define SCT0_CAPCTRL3_H		(*(volatile uint16_t*)0x1C01820E)
#define SCT0_CAPCTRL4_H		(*(volatile uint16_t*)0x1C018212)
#define SCT0_CAPCTRL5_H		(*(volatile uint16_t*)0x1C018216)
#define SCT0_CAPCTRL6_H		(*(volatile uint16_t*)0x1C01821A)
#define SCT0_CAPCTRL7_H		(*(volatile uint16_t*)0x1C01821E)
#define SCT0_CAPCTRL8_H		(*(volatile uint16_t*)0x1C018222)
#define SCT0_CAPCTRL9_H		(*(volatile uint16_t*)0x1C018226)
#define SCT0_CAPCTRL10_H	(*(volatile uint16_t*)0x1C01822A)
#define SCT0_CAPCTRL11_H	(*(volatile uint16_t*)0x1C01822E)
#define SCT0_CAPCTRL12_H	(*(volatile uint16_t*)0x1C018232)
#define SCT0_CAPCTRL13_H	(*(volatile uint16_t*)0x1C018236)
#define SCT0_CAPCTRL14_H	(*(volatile uint16_t*)0x1C01823A)
#define SCT0_CAPCTRL15_H	(*(volatile uint16_t*)0x1C01823E)
#define SCT0_FRACMATREL0	(*(volatile uint32_t*)0x1C018240)
#define SCT0_FRACMATREL1	(*(volatile uint32_t*)0x1C018244)
#define SCT0_FRACMATREL2	(*(volatile uint32_t*)0x1C018248)
#define SCT0_FRACMATREL3	(*(volatile uint32_t*)0x1C01824C)
#define SCT0_FRACMATREL4	(*(volatile uint32_t*)0x1C018250)
#define SCT0_FRACMATREL5	(*(volatile uint32_t*)0x1C018254)
#define SCT0_FRACMATREL0_L	(*(volatile uint16_t*)0x1C018240)
#define SCT0_FRACMATREL1_L	(*(volatile uint16_t*)0x1C018244)
#define SCT0_FRACMATREL2_L	(*(volatile uint16_t*)0x1C018248)
#define SCT0_FRACMATREL3_L	(*(volatile uint16_t*)0x1C01824C)
#define SCT0_FRACMATREL4_L	(*(volatile uint16_t*)0x1C018250)
#define SCT0_FRACMATREL5_L	(*(volatile uint16_t*)0x1C018254)
#define SCT0_FRACMATREL0_H	(*(volatile uint16_t*)0x1C018242)
#define SCT0_FRACMATREL1_H	(*(volatile uint16_t*)0x1C018246)
#define SCT0_FRACMATREL2_H	(*(volatile uint16_t*)0x1C01824A)
#define SCT0_FRACMATREL3_H	(*(volatile uint16_t*)0x1C01824E)
#define SCT0_FRACMATREL4_H	(*(volatile uint16_t*)0x1C018252)
#define SCT0_FRACMATREL5_H	(*(volatile uint16_t*)0x1C018256)
#define SCT0_EV0_STATE		(*(volatile uint32_t*)0x1C018300)
#define SCT0_EV0_CTRL		(*(volatile uint32_t*)0x1C018304)
#define SCT0_EV1_STATE		(*(volatile uint32_t*)0x1C018308)
#define SCT0_EV1_CTRL		(*(volatile uint32_t*)0x1C01830C)
#define SCT0_EV2_STATE		(*(volatile uint32_t*)0x1C018310)
#define SCT0_EV2_CTRL		(*(volatile uint32_t*)0x1C018314)
#define SCT0_EV3_STATE		(*(volatile uint32_t*)0x1C018318)
#define SCT0_EV3_CTRL		(*(volatile uint32_t*)0x1C01831C)
#define SCT0_EV4_STATE		(*(volatile uint32_t*)0x1C018320)
#define SCT0_EV4_CTRL		(*(volatile uint32_t*)0x1C018324)
#define SCT0_EV5_STATE		(*(volatile uint32_t*)0x1C018328)
#define SCT0_EV5_CTRL		(*(volatile uint32_t*)0x1C01832C)
#define SCT0_EV6_STATE		(*(volatile uint32_t*)0x1C018330)
#define SCT0_EV6_CTRL		(*(volatile uint32_t*)0x1C018334)
#define SCT0_EV7_STATE		(*(volatile uint32_t*)0x1C018338)
#define SCT0_EV7_CTRL		(*(volatile uint32_t*)0x1C01833C)
#define SCT0_EV8_STATE		(*(volatile uint32_t*)0x1C018340)
#define SCT0_EV8_CTRL		(*(volatile uint32_t*)0x1C018344)
#define SCT0_EV9_STATE		(*(volatile uint32_t*)0x1C018348)
#define SCT0_EV9_CTRL		(*(volatile uint32_t*)0x1C01834C)
#define SCT0_EV10_STATE		(*(volatile uint32_t*)0x1C018350)
#define SCT0_EV10_CTRL		(*(volatile uint32_t*)0x1C018354)
#define SCT0_EV11_STATE		(*(volatile uint32_t*)0x1C018358)
#define SCT0_EV11_CTRL		(*(volatile uint32_t*)0x1C01835C)
#define SCT0_EV12_STATE		(*(volatile uint32_t*)0x1C018360)
#define SCT0_EV12_CTRL		(*(volatile uint32_t*)0x1C018364)
#define SCT0_EV13_STATE		(*(volatile uint32_t*)0x1C018368)
#define SCT0_EV13_CTRL		(*(volatile uint32_t*)0x1C01836C)
#define SCT0_EV14_STATE		(*(volatile uint32_t*)0x1C018370)
#define SCT0_EV14_CTRL		(*(volatile uint32_t*)0x1C018374)
#define SCT0_EV15_STATE		(*(volatile uint32_t*)0x1C018378)
#define SCT0_EV15_CTRL		(*(volatile uint32_t*)0x1C01837C)
#define SCT0_OUT0_SET		(*(volatile uint32_t*)0x1C018500)
#define SCT0_OUT0_CLR		(*(volatile uint32_t*)0x1C018504)
#define SCT0_OUT1_SET		(*(volatile uint32_t*)0x1C018508)
#define SCT0_OUT1_CLR		(*(volatile uint32_t*)0x1C01850C)
#define SCT0_OUT2_SET		(*(volatile uint32_t*)0x1C018510)
#define SCT0_OUT2_CLR		(*(volatile uint32_t*)0x1C018514)
#define SCT0_OUT3_SET		(*(volatile uint32_t*)0x1C018518)
#define SCT0_OUT3_CLR		(*(volatile uint32_t*)0x1C01851C)
#define SCT0_OUT4_SET		(*(volatile uint32_t*)0x1C018520)
#define SCT0_OUT4_CLR		(*(volatile uint32_t*)0x1C018524)
#define SCT0_OUT5_SET		(*(volatile uint32_t*)0x1C018528)
#define SCT0_OUT5_CLR		(*(volatile uint32_t*)0x1C01852C)
#define SCT0_OUT6_SET		(*(volatile uint32_t*)0x1C018530)
#define SCT0_OUT6_CLR		(*(volatile uint32_t*)0x1C018534)
#define SCT0_OUT7_SET		(*(volatile uint32_t*)0x1C018538)
#define SCT0_OUT7_CLR		(*(volatile uint32_t*)0x1C01853C)
#define SCT0_OUT8_SET		(*(volatile uint32_t*)0x1C018540)
#define SCT0_OUT8_CLR		(*(volatile uint32_t*)0x1C018544)
#define SCT0_OUT9_SET		(*(volatile uint32_t*)0x1C018548)
#define SCT0_OUT9_CLR		(*(volatile uint32_t*)0x1C01854C)

#define SCT1_CONFIG			(*(volatile uint32_t*)0x1C01C000)
#define SCT1_CTRL			(*(volatile uint32_t*)0x1C01C004)
#define SCT1_CTRL_L			(*(volatile uint16_t*)0x1C01C004)
#define SCT1_CTRL_H			(*(volatile uint16_t*)0x1C01C006)
#define SCT1_LIMIT			(*(volatile uint32_t*)0x1C01C008)
#define SCT1_LIMIT_L		(*(volatile uint16_t*)0x1C01C008)
#define SCT1_LIMIT_H		(*(volatile uint16_t*)0x1C01C00A)
#define SCT1_HALT			(*(volatile uint32_t*)0x1C01C00C)
#define SCT1_HALT_L			(*(volatile uint16_t*)0x1C01C00C)
#define SCT1_HALT_H			(*(volatile uint16_t*)0x1C01C00E)
#define SCT1_STOP			(*(volatile uint32_t*)0x1C01C010)
#define SCT1_STOP_L			(*(volatile uint16_t*)0x1C01C010)
#define SCT1_STOP_H			(*(volatile uint16_t*)0x1C01C012)
#define SCT1_START			(*(volatile uint32_t*)0x1C01C014)
#define SCT1_START_L		(*(volatile uint16_t*)0x1C01C014)
#define SCT1_START_H		(*(volatile uint16_t*)0x1C01C016)
#define SCT1_DITHER			(*(volatile uint32_t*)0x1C01C018)
#define SCT1_DITHER_L		(*(volatile uint16_t*)0x1C01C018)
#define SCT1_DITHER_H		(*(volatile uint16_t*)0x1C01C01A)
#define SCT1_COUNT			(*(volatile uint32_t*)0x1C01C040)
#define SCT1_COUNT_L		(*(volatile uint16_t*)0x1C01C040)
#define SCT1_COUNT_H		(*(volatile uint16_t*)0x1C01C042)
#define SCT1_STATE			(*(volatile uint32_t*)0x1C01C044)
#define SCT1_STALE_L		(*(volatile uint16_t*)0x1C01C044)
#define SCT1_STALE_H		(*(volatile uint16_t*)0x1C01C046)
#define SCT1_INPUT			(*(volatile uint32_t*)0x1C01C048)
#define SCT1_REGMODE		(*(volatile uint32_t*)0x1C01C04C)
#define SCT1_REGMODE_L		(*(volatile uint32_t*)0x1C01C04C)
#define SCT1_REGMODE_H		(*(volatile uint32_t*)0x1C01C04E)
#define SCT1_OUTPUT			(*(volatile uint32_t*)0x1C01C050)
#define SCT1_OUTPUTDIRCTRL	(*(volatile uint32_t*)0x1C01C054)
#define SCT1_RES			(*(volatile uint32_t*)0x1C01C058)
#define SCT1_DMAREQ0		(*(volatile uint32_t*)0x1C01C05C)
#define SCT1_DMAREQ1		(*(volatile uint32_t*)0x1C01C060)
#define SCT1_EVEN			(*(volatile uint32_t*)0x1C01C0F0)
#define SCT1_EVFLAG			(*(volatile uint32_t*)0x1C01C0F4)
#define SCT1_CONEN			(*(volatile uint32_t*)0x1C01C0F8)
#define SCT1_CONFLAG		(*(volatile uint32_t*)0x1C01C0FC)
#define SCT1_MATCH0			(*(volatile uint32_t*)0x1C01C100)
#define SCT1_MATCH1			(*(volatile uint32_t*)0x1C01C104)
#define SCT1_MATCH2			(*(volatile uint32_t*)0x1C01C108)
#define SCT1_MATCH3			(*(volatile uint32_t*)0x1C01C10C)
#define SCT1_MATCH4			(*(volatile uint32_t*)0x1C01C110)
#define SCT1_MATCH5			(*(volatile uint32_t*)0x1C01C114)
#define SCT1_MATCH6			(*(volatile uint32_t*)0x1C01C118)
#define SCT1_MATCH7			(*(volatile uint32_t*)0x1C01C11C)
#define SCT1_MATCH8			(*(volatile uint32_t*)0x1C01C120)
#define SCT1_MATCH9			(*(volatile uint32_t*)0x1C01C124)
#define SCT1_MATCH10		(*(volatile uint32_t*)0x1C01C128)
#define SCT1_MATCH11		(*(volatile uint32_t*)0x1C01C12C)
#define SCT1_MATCH12		(*(volatile uint32_t*)0x1C01C130)
#define SCT1_MATCH13		(*(volatile uint32_t*)0x1C01C134)
#define SCT1_MATCH14		(*(volatile uint32_t*)0x1C01C138)
#define SCT1_MATCH15		(*(volatile uint32_t*)0x1C01C13C)
#define SCT1_MATCH0_L		(*(volatile uint16_t*)0x1C01C100)
#define SCT1_MATCH1_L		(*(volatile uint16_t*)0x1C01C104)
#define SCT1_MATCH2_L		(*(volatile uint16_t*)0x1C01C108)
#define SCT1_MATCH3_L		(*(volatile uint16_t*)0x1C01C10C)
#define SCT1_MATCH4_L		(*(volatile uint16_t*)0x1C01C110)
#define SCT1_MATCH5_L		(*(volatile uint16_t*)0x1C01C114)
#define SCT1_MATCH6_L		(*(volatile uint16_t*)0x1C01C118)
#define SCT1_MATCH7_L		(*(volatile uint16_t*)0x1C01C11C)
#define SCT1_MATCH8_L		(*(volatile uint16_t*)0x1C01C120)
#define SCT1_MATCH9_L		(*(volatile uint16_t*)0x1C01C124)
#define SCT1_MATCH10_L		(*(volatile uint16_t*)0x1C01C128)
#define SCT1_MATCH11_L		(*(volatile uint16_t*)0x1C01C12C)
#define SCT1_MATCH12_L		(*(volatile uint16_t*)0x1C01C130)
#define SCT1_MATCH13_L		(*(volatile uint16_t*)0x1C01C134)
#define SCT1_MATCH14_L		(*(volatile uint16_t*)0x1C01C138)
#define SCT1_MATCH15_L		(*(volatile uint16_t*)0x1C01C13C)
#define SCT1_MATCH0_H		(*(volatile uint16_t*)0x1C01C100)
#define SCT1_MATCH1_H		(*(volatile uint16_t*)0x1C01C104)
#define SCT1_MATCH2_H		(*(volatile uint16_t*)0x1C01C108)
#define SCT1_MATCH3_H		(*(volatile uint16_t*)0x1C01C10C)
#define SCT1_MATCH4_H		(*(volatile uint16_t*)0x1C01C110)
#define SCT1_MATCH5_H		(*(volatile uint16_t*)0x1C01C114)
#define SCT1_MATCH6_H		(*(volatile uint16_t*)0x1C01C118)
#define SCT1_MATCH7_H		(*(volatile uint16_t*)0x1C01C11C)
#define SCT1_MATCH8_H		(*(volatile uint16_t*)0x1C01C120)
#define SCT1_MATCH9_H		(*(volatile uint16_t*)0x1C01C124)
#define SCT1_MATCH10_H		(*(volatile uint16_t*)0x1C01C128)
#define SCT1_MATCH11_H		(*(volatile uint16_t*)0x1C01C12C)
#define SCT1_MATCH12_H		(*(volatile uint16_t*)0x1C01C130)
#define SCT1_MATCH13_H		(*(volatile uint16_t*)0x1C01C134)
#define SCT1_MATCH14_H		(*(volatile uint16_t*)0x1C01C138)
#define SCT1_MATCH15_H		(*(volatile uint16_t*)0x1C01C13C)
#define SCT1_CAP0			(*(volatile uint32_t*)0x1C01C100)
#define SCT1_CAP1			(*(volatile uint32_t*)0x1C01C104)
#define SCT1_CAP2			(*(volatile uint32_t*)0x1C01C108)
#define SCT1_CAP3			(*(volatile uint32_t*)0x1C01C10C)
#define SCT1_CAP4			(*(volatile uint32_t*)0x1C01C110)
#define SCT1_CAP5			(*(volatile uint32_t*)0x1C01C114)
#define SCT1_CAP6			(*(volatile uint32_t*)0x1C01C118)
#define SCT1_CAP7			(*(volatile uint32_t*)0x1C01C11C)
#define SCT1_CAP8			(*(volatile uint32_t*)0x1C01C120)
#define SCT1_CAP9			(*(volatile uint32_t*)0x1C01C124)
#define SCT1_CAP10			(*(volatile uint32_t*)0x1C01C128)
#define SCT1_CAP11			(*(volatile uint32_t*)0x1C01C12C)
#define SCT1_CAP12			(*(volatile uint32_t*)0x1C01C130)
#define SCT1_CAP13			(*(volatile uint32_t*)0x1C01C134)
#define SCT1_CAP14			(*(volatile uint32_t*)0x1C01C138)
#define SCT1_CAP15			(*(volatile uint32_t*)0x1C01C13C)
#define SCT1_CAP0_L			(*(volatile uint16_t*)0x1C01C100)
#define SCT1_CAP1_L			(*(volatile uint16_t*)0x1C01C104)
#define SCT1_CAP2_L			(*(volatile uint16_t*)0x1C01C108)
#define SCT1_CAP3_L			(*(volatile uint16_t*)0x1C01C10C)
#define SCT1_CAP4_L			(*(volatile uint16_t*)0x1C01C110)
#define SCT1_CAP5_L			(*(volatile uint16_t*)0x1C01C114)
#define SCT1_CAP6_L			(*(volatile uint16_t*)0x1C01C118)
#define SCT1_CAP7_L			(*(volatile uint16_t*)0x1C01C11C)
#define SCT1_CAP8_L			(*(volatile uint16_t*)0x1C01C120)
#define SCT1_CAP9_L			(*(volatile uint16_t*)0x1C01C124)
#define SCT1_CAP10_L		(*(volatile uint16_t*)0x1C01C128)
#define SCT1_CAP11_L		(*(volatile uint16_t*)0x1C01C12C)
#define SCT1_CAP12_L		(*(volatile uint16_t*)0x1C01C130)
#define SCT1_CAP13_L		(*(volatile uint16_t*)0x1C01C134)
#define SCT1_CAP14_L		(*(volatile uint16_t*)0x1C01C138)
#define SCT1_CAP15_L		(*(volatile uint16_t*)0x1C01C13C)
#define SCT1_CAP0_H			(*(volatile uint16_t*)0x1C01C100)
#define SCT1_CAP1_H			(*(volatile uint16_t*)0x1C01C104)
#define SCT1_CAP2_H			(*(volatile uint16_t*)0x1C01C108)
#define SCT1_CAP3_H			(*(volatile uint16_t*)0x1C01C10C)
#define SCT1_CAP4_H			(*(volatile uint16_t*)0x1C01C110)
#define SCT1_CAP5_H			(*(volatile uint16_t*)0x1C01C114)
#define SCT1_CAP6_H			(*(volatile uint16_t*)0x1C01C118)
#define SCT1_CAP7_H			(*(volatile uint16_t*)0x1C01C11C)
#define SCT1_CAP8_H			(*(volatile uint16_t*)0x1C01C120)
#define SCT1_CAP9_H			(*(volatile uint16_t*)0x1C01C124)
#define SCT1_CAP10_H		(*(volatile uint16_t*)0x1C01C128)
#define SCT1_CAP11_H		(*(volatile uint16_t*)0x1C01C12C)
#define SCT1_CAP12_H		(*(volatile uint16_t*)0x1C01C130)
#define SCT1_CAP13_H		(*(volatile uint16_t*)0x1C01C134)
#define SCT1_CAP14_H		(*(volatile uint16_t*)0x1C01C138)
#define SCT1_CAP15_H		(*(volatile uint16_t*)0x1C01C13C)
#define SCT1_FRACMAT0		(*(volatile uint32_t*)0x1C01C140)
#define SCT1_FRACMAT1		(*(volatile uint32_t*)0x1C01C144)
#define SCT1_FRACMAT2		(*(volatile uint32_t*)0x1C01C148)
#define SCT1_FRACMAT3		(*(volatile uint32_t*)0x1C01C14C)
#define SCT1_FRACMAT4		(*(volatile uint32_t*)0x1C01C150)
#define SCT1_FRACMAT5		(*(volatile uint32_t*)0x1C01C154)
#define SCT1_FRACMAT0_L		(*(volatile uint16_t*)0x1C01C140)
#define SCT1_FRACMAT1_L		(*(volatile uint16_t*)0x1C01C144)
#define SCT1_FRACMAT2_L		(*(volatile uint16_t*)0x1C01C148)
#define SCT1_FRACMAT3_L		(*(volatile uint16_t*)0x1C01C14C)
#define SCT1_FRACMAT4_L		(*(volatile uint16_t*)0x1C01C150)
#define SCT1_FRACMAT5_L		(*(volatile uint16_t*)0x1C01C154)
#define SCT1_FRACMAT0_H		(*(volatile uint16_t*)0x1C01C142)
#define SCT1_FRACMAT1_H		(*(volatile uint16_t*)0x1C01C146)
#define SCT1_FRACMAT2_H		(*(volatile uint16_t*)0x1C01C14A)
#define SCT1_FRACMAT3_H		(*(volatile uint16_t*)0x1C01C14E)
#define SCT1_FRACMAT4_H		(*(volatile uint16_t*)0x1C01C152)
#define SCT1_FRACMAT5_H		(*(volatile uint16_t*)0x1C01C156)
#define SCT1_MATCHREL0		(*(volatile uint32_t*)0x1C01C200)
#define SCT1_MATCHREL1		(*(volatile uint32_t*)0x1C01C204)
#define SCT1_MATCHREL2		(*(volatile uint32_t*)0x1C01C208)
#define SCT1_MATCHREL3		(*(volatile uint32_t*)0x1C01C20C)
#define SCT1_MATCHREL4		(*(volatile uint32_t*)0x1C01C210)
#define SCT1_MATCHREL5		(*(volatile uint32_t*)0x1C01C214)
#define SCT1_MATCHREL6		(*(volatile uint32_t*)0x1C01C218)
#define SCT1_MATCHREL7		(*(volatile uint32_t*)0x1C01C21C)
#define SCT1_MATCHREL8		(*(volatile uint32_t*)0x1C01C220)
#define SCT1_MATCHREL9		(*(volatile uint32_t*)0x1C01C224)
#define SCT1_MATCHREL10		(*(volatile uint32_t*)0x1C01C228)
#define SCT1_MATCHREL11		(*(volatile uint32_t*)0x1C01C22C)
#define SCT1_MATCHREL12		(*(volatile uint32_t*)0x1C01C230)
#define SCT1_MATCHREL13		(*(volatile uint32_t*)0x1C01C234)
#define SCT1_MATCHREL14		(*(volatile uint32_t*)0x1C01C238)
#define SCT1_MATCHREL15		(*(volatile uint32_t*)0x1C01C23C)
#define SCT1_MATCHREL0_L	(*(volatile uint16_t*)0x1C01C200)
#define SCT1_MATCHREL1_L	(*(volatile uint16_t*)0x1C01C204)
#define SCT1_MATCHREL2_L	(*(volatile uint16_t*)0x1C01C208)
#define SCT1_MATCHREL3_L	(*(volatile uint16_t*)0x1C01C20C)
#define SCT1_MATCHREL4_L	(*(volatile uint16_t*)0x1C01C210)
#define SCT1_MATCHREL5_L	(*(volatile uint16_t*)0x1C01C214)
#define SCT1_MATCHREL6_L	(*(volatile uint16_t*)0x1C01C218)
#define SCT1_MATCHREL7_L	(*(volatile uint16_t*)0x1C01C21C)
#define SCT1_MATCHREL8_L	(*(volatile uint16_t*)0x1C01C220)
#define SCT1_MATCHREL9_L	(*(volatile uint16_t*)0x1C01C224)
#define SCT1_MATCHREL10_L	(*(volatile uint16_t*)0x1C01C228)
#define SCT1_MATCHREL11_L	(*(volatile uint16_t*)0x1C01C22C)
#define SCT1_MATCHREL12_L	(*(volatile uint16_t*)0x1C01C230)
#define SCT1_MATCHREL13_L	(*(volatile uint16_t*)0x1C01C234)
#define SCT1_MATCHREL14_L	(*(volatile uint16_t*)0x1C01C238)
#define SCT1_MATCHREL15_L	(*(volatile uint16_t*)0x1C01C23C)
#define SCT1_MATCHREL0_H	(*(volatile uint16_t*)0x1C01C202)
#define SCT1_MATCHREL1_H	(*(volatile uint16_t*)0x1C01C206)
#define SCT1_MATCHREL2_H	(*(volatile uint16_t*)0x1C01C20A)
#define SCT1_MATCHREL3_H	(*(volatile uint16_t*)0x1C01C20E)
#define SCT1_MATCHREL4_H	(*(volatile uint16_t*)0x1C01C212)
#define SCT1_MATCHREL5_H	(*(volatile uint16_t*)0x1C01C216)
#define SCT1_MATCHREL6_H	(*(volatile uint16_t*)0x1C01C21A)
#define SCT1_MATCHREL7_H	(*(volatile uint16_t*)0x1C01C21E)
#define SCT1_MATCHREL8_H	(*(volatile uint16_t*)0x1C01C222)
#define SCT1_MATCHREL9_H	(*(volatile uint16_t*)0x1C01C226)
#define SCT1_MATCHREL10_H	(*(volatile uint16_t*)0x1C01C22A)
#define SCT1_MATCHREL11_H	(*(volatile uint16_t*)0x1C01C22E)
#define SCT1_MATCHREL12_H	(*(volatile uint16_t*)0x1C01C232)
#define SCT1_MATCHREL13_H	(*(volatile uint16_t*)0x1C01C236)
#define SCT1_MATCHREL14_H	(*(volatile uint16_t*)0x1C01C23A)
#define SCT1_MATCHREL15_H	(*(volatile uint16_t*)0x1C01C23E)
#define SCT1_CAPCTRL0		(*(volatile uint32_t*)0x1C01C200)
#define SCT1_CAPCTRL1		(*(volatile uint32_t*)0x1C01C204)
#define SCT1_CAPCTRL2		(*(volatile uint32_t*)0x1C01C208)
#define SCT1_CAPCTRL3		(*(volatile uint32_t*)0x1C01C20C)
#define SCT1_CAPCTRL4		(*(volatile uint32_t*)0x1C01C210)
#define SCT1_CAPCTRL5		(*(volatile uint32_t*)0x1C01C214)
#define SCT1_CAPCTRL6		(*(volatile uint32_t*)0x1C01C218)
#define SCT1_CAPCTRL7		(*(volatile uint32_t*)0x1C01C21C)
#define SCT1_CAPCTRL8		(*(volatile uint32_t*)0x1C01C220)
#define SCT1_CAPCTRL9		(*(volatile uint32_t*)0x1C01C224)
#define SCT1_CAPCTRL10		(*(volatile uint32_t*)0x1C01C228)
#define SCT1_CAPCTRL11		(*(volatile uint32_t*)0x1C01C22C)
#define SCT1_CAPCTRL12		(*(volatile uint32_t*)0x1C01C230)
#define SCT1_CAPCTRL13		(*(volatile uint32_t*)0x1C01C234)
#define SCT1_CAPCTRL14		(*(volatile uint32_t*)0x1C01C238)
#define SCT1_CAPCTRL15		(*(volatile uint32_t*)0x1C01C23C)
#define SCT1_CAPCTRL0_L		(*(volatile uint16_t*)0x1C01C200)
#define SCT1_CAPCTRL1_L		(*(volatile uint16_t*)0x1C01C204)
#define SCT1_CAPCTRL2_L		(*(volatile uint16_t*)0x1C01C208)
#define SCT1_CAPCTRL3_L		(*(volatile uint16_t*)0x1C01C20C)
#define SCT1_CAPCTRL4_L		(*(volatile uint16_t*)0x1C01C210)
#define SCT1_CAPCTRL5_L		(*(volatile uint16_t*)0x1C01C214)
#define SCT1_CAPCTRL6_L		(*(volatile uint16_t*)0x1C01C218)
#define SCT1_CAPCTRL7_L		(*(volatile uint16_t*)0x1C01C21C)
#define SCT1_CAPCTRL8_L		(*(volatile uint16_t*)0x1C01C220)
#define SCT1_CAPCTRL9_L		(*(volatile uint16_t*)0x1C01C224)
#define SCT1_CAPCTRL10_L	(*(volatile uint16_t*)0x1C01C228)
#define SCT1_CAPCTRL11_L	(*(volatile uint16_t*)0x1C01C22C)
#define SCT1_CAPCTRL12_L	(*(volatile uint16_t*)0x1C01C230)
#define SCT1_CAPCTRL13_L	(*(volatile uint16_t*)0x1C01C234)
#define SCT1_CAPCTRL14_L	(*(volatile uint16_t*)0x1C01C238)
#define SCT1_CAPCTRL15_L	(*(volatile uint16_t*)0x1C01C23C)
#define SCT1_CAPCTRL0_H		(*(volatile uint16_t*)0x1C01C202)
#define SCT1_CAPCTRL1_H		(*(volatile uint16_t*)0x1C01C206)
#define SCT1_CAPCTRL2_H		(*(volatile uint16_t*)0x1C01C20A)
#define SCT1_CAPCTRL3_H		(*(volatile uint16_t*)0x1C01C20E)
#define SCT1_CAPCTRL4_H		(*(volatile uint16_t*)0x1C01C212)
#define SCT1_CAPCTRL5_H		(*(volatile uint16_t*)0x1C01C216)
#define SCT1_CAPCTRL6_H		(*(volatile uint16_t*)0x1C01C21A)
#define SCT1_CAPCTRL7_H		(*(volatile uint16_t*)0x1C01C21E)
#define SCT1_CAPCTRL8_H		(*(volatile uint16_t*)0x1C01C222)
#define SCT1_CAPCTRL9_H		(*(volatile uint16_t*)0x1C01C226)
#define SCT1_CAPCTRL10_H	(*(volatile uint16_t*)0x1C01C22A)
#define SCT1_CAPCTRL11_H	(*(volatile uint16_t*)0x1C01C22E)
#define SCT1_CAPCTRL12_H	(*(volatile uint16_t*)0x1C01C232)
#define SCT1_CAPCTRL13_H	(*(volatile uint16_t*)0x1C01C236)
#define SCT1_CAPCTRL14_H	(*(volatile uint16_t*)0x1C01C23A)
#define SCT1_CAPCTRL15_H	(*(volatile uint16_t*)0x1C01C23E)
#define SCT1_FRACMATREL0	(*(volatile uint32_t*)0x1C01C240)
#define SCT1_FRACMATREL1	(*(volatile uint32_t*)0x1C01C244)
#define SCT1_FRACMATREL2	(*(volatile uint32_t*)0x1C01C248)
#define SCT1_FRACMATREL3	(*(volatile uint32_t*)0x1C01C24C)
#define SCT1_FRACMATREL4	(*(volatile uint32_t*)0x1C01C250)
#define SCT1_FRACMATREL5	(*(volatile uint32_t*)0x1C01C254)
#define SCT1_FRACMATREL0_L	(*(volatile uint16_t*)0x1C01C240)
#define SCT1_FRACMATREL1_L	(*(volatile uint16_t*)0x1C01C244)
#define SCT1_FRACMATREL2_L	(*(volatile uint16_t*)0x1C01C248)
#define SCT1_FRACMATREL3_L	(*(volatile uint16_t*)0x1C01C24C)
#define SCT1_FRACMATREL4_L	(*(volatile uint16_t*)0x1C01C250)
#define SCT1_FRACMATREL5_L	(*(volatile uint16_t*)0x1C01C254)
#define SCT1_FRACMATREL0_H	(*(volatile uint16_t*)0x1C01C242)
#define SCT1_FRACMATREL1_H	(*(volatile uint16_t*)0x1C01C246)
#define SCT1_FRACMATREL2_H	(*(volatile uint16_t*)0x1C01C24A)
#define SCT1_FRACMATREL3_H	(*(volatile uint16_t*)0x1C01C24E)
#define SCT1_FRACMATREL4_H	(*(volatile uint16_t*)0x1C01C252)
#define SCT1_FRACMATREL5_H	(*(volatile uint16_t*)0x1C01C256)
#define SCT1_EV0_STATE		(*(volatile uint32_t*)0x1C01C300)
#define SCT1_EV0_CTRL		(*(volatile uint32_t*)0x1C01C304)
#define SCT1_EV1_STATE		(*(volatile uint32_t*)0x1C01C308)
#define SCT1_EV1_CTRL		(*(volatile uint32_t*)0x1C01C30C)
#define SCT1_EV2_STATE		(*(volatile uint32_t*)0x1C01C310)
#define SCT1_EV2_CTRL		(*(volatile uint32_t*)0x1C01C314)
#define SCT1_EV3_STATE		(*(volatile uint32_t*)0x1C01C318)
#define SCT1_EV3_CTRL		(*(volatile uint32_t*)0x1C01C31C)
#define SCT1_EV4_STATE		(*(volatile uint32_t*)0x1C01C320)
#define SCT1_EV4_CTRL		(*(volatile uint32_t*)0x1C01C324)
#define SCT1_EV5_STATE		(*(volatile uint32_t*)0x1C01C328)
#define SCT1_EV5_CTRL		(*(volatile uint32_t*)0x1C01C32C)
#define SCT1_EV6_STATE		(*(volatile uint32_t*)0x1C01C330)
#define SCT1_EV6_CTRL		(*(volatile uint32_t*)0x1C01C334)
#define SCT1_EV7_STATE		(*(volatile uint32_t*)0x1C01C338)
#define SCT1_EV7_CTRL		(*(volatile uint32_t*)0x1C01C33C)
#define SCT1_EV8_STATE		(*(volatile uint32_t*)0x1C01C340)
#define SCT1_EV8_CTRL		(*(volatile uint32_t*)0x1C01C344)
#define SCT1_EV9_STATE		(*(volatile uint32_t*)0x1C01C348)
#define SCT1_EV9_CTRL		(*(volatile uint32_t*)0x1C01C34C)
#define SCT1_EV10_STATE		(*(volatile uint32_t*)0x1C01C350)
#define SCT1_EV10_CTRL		(*(volatile uint32_t*)0x1C01C354)
#define SCT1_EV11_STATE		(*(volatile uint32_t*)0x1C01C358)
#define SCT1_EV11_CTRL		(*(volatile uint32_t*)0x1C01C35C)
#define SCT1_EV12_STATE		(*(volatile uint32_t*)0x1C01C360)
#define SCT1_EV12_CTRL		(*(volatile uint32_t*)0x1C01C364)
#define SCT1_EV13_STATE		(*(volatile uint32_t*)0x1C01C368)
#define SCT1_EV13_CTRL		(*(volatile uint32_t*)0x1C01C36C)
#define SCT1_EV14_STATE		(*(volatile uint32_t*)0x1C01C370)
#define SCT1_EV14_CTRL		(*(volatile uint32_t*)0x1C01C374)
#define SCT1_EV15_STATE		(*(volatile uint32_t*)0x1C01C378)
#define SCT1_EV15_CTRL		(*(volatile uint32_t*)0x1C01C37C)
#define SCT1_OUT0_SET		(*(volatile uint32_t*)0x1C01C500)
#define SCT1_OUT0_CLR		(*(volatile uint32_t*)0x1C01C504)
#define SCT1_OUT1_SET		(*(volatile uint32_t*)0x1C01C508)
#define SCT1_OUT1_CLR		(*(volatile uint32_t*)0x1C01C50C)
#define SCT1_OUT2_SET		(*(volatile uint32_t*)0x1C01C510)
#define SCT1_OUT2_CLR		(*(volatile uint32_t*)0x1C01C514)
#define SCT1_OUT3_SET		(*(volatile uint32_t*)0x1C01C518)
#define SCT1_OUT3_CLR		(*(volatile uint32_t*)0x1C01C51C)
#define SCT1_OUT4_SET		(*(volatile uint32_t*)0x1C01C520)
#define SCT1_OUT4_CLR		(*(volatile uint32_t*)0x1C01C524)
#define SCT1_OUT5_SET		(*(volatile uint32_t*)0x1C01C528)
#define SCT1_OUT5_CLR		(*(volatile uint32_t*)0x1C01C52C)
#define SCT1_OUT6_SET		(*(volatile uint32_t*)0x1C01C530)
#define SCT1_OUT6_CLR		(*(volatile uint32_t*)0x1C01C534)
#define SCT1_OUT7_SET		(*(volatile uint32_t*)0x1C01C538)
#define SCT1_OUT7_CLR		(*(volatile uint32_t*)0x1C01C53C)
#define SCT1_OUT8_SET		(*(volatile uint32_t*)0x1C01C540)
#define SCT1_OUT8_CLR		(*(volatile uint32_t*)0x1C01C544)
#define SCT1_OUT9_SET		(*(volatile uint32_t*)0x1C01C548)
#define SCT1_OUT9_CLR		(*(volatile uint32_t*)0x1C01C54C)

/* SCT2, SCT3 */
#define SCT2_CONFIG			(*(volatile uint32_t*)0x1C020000)
#define SCT2_CTRL			(*(volatile uint32_t*)0x1C020004)
#define SCT2_CTRL_L			(*(volatile uint16_t*)0x1C020004)
#define SCT2_CTRL_H			(*(volatile uint16_t*)0x1C020006)
#define SCT2_LIMIT			(*(volatile uint32_t*)0x1C020008)
#define SCT2_LIMIT_L		(*(volatile uint16_t*)0x1C020008)
#define SCT2_LIMIT_H		(*(volatile uint16_t*)0x1C02000A)
#define SCT2_HALT			(*(volatile uint32_t*)0x1C02000C)
#define SCT2_HALT_L			(*(volatile uint16_t*)0x1C02000C)
#define SCT2_HALT_H			(*(volatile uint16_t*)0x1C02000E)
#define SCT2_STOP			(*(volatile uint32_t*)0x1C020010)
#define SCT2_STOP_L			(*(volatile uint16_t*)0x1C020010)
#define SCT2_STOP_H			(*(volatile uint16_t*)0x1C020012)
#define SCT2_START			(*(volatile uint32_t*)0x1C020014)
#define SCT2_START_L		(*(volatile uint16_t*)0x1C020014)
#define SCT2_START_H		(*(volatile uint16_t*)0x1C020016)
#define SCT2_COUNT			(*(volatile uint32_t*)0x1C020040)
#define SCT2_COUNT_L		(*(volatile uint16_t*)0x1C020040)
#define SCT2_COUNT_H		(*(volatile uint16_t*)0x1C020042)
#define SCT2_STATE			(*(volatile uint32_t*)0x1C020044)
#define SCT2_STALE_L		(*(volatile uint16_t*)0x1C020044)
#define SCT2_STALE_H		(*(volatile uint16_t*)0x1C020046)
#define SCT2_INPUT			(*(volatile uint32_t*)0x1C020048)
#define SCT2_REGMODE		(*(volatile uint32_t*)0x1C02004C)
#define SCT2_REGMODE_L		(*(volatile uint32_t*)0x1C02004C)
#define SCT2_REGMODE_H		(*(volatile uint32_t*)0x1C02004E)
#define SCT2_OUTPUT			(*(volatile uint32_t*)0x1C020050)
#define SCT2_OUTPUTDIRCTRL	(*(volatile uint32_t*)0x1C020054)
#define SCT2_RES			(*(volatile uint32_t*)0x1C020058)
#define SCT2_DMAREQ0		(*(volatile uint32_t*)0x1C02005C)
#define SCT2_DMAREQ1		(*(volatile uint32_t*)0x1C020060)
#define SCT2_EVEN			(*(volatile uint32_t*)0x1C0200F0)
#define SCT2_EVFLAG			(*(volatile uint32_t*)0x1C0200F4)
#define SCT2_CONEN			(*(volatile uint32_t*)0x1C0200F8)
#define SCT2_CONFLAG		(*(volatile uint32_t*)0x1C0200FC)
#define SCT2_MATCH0			(*(volatile uint32_t*)0x1C020100)
#define SCT2_MATCH1			(*(volatile uint32_t*)0x1C020104)
#define SCT2_MATCH2			(*(volatile uint32_t*)0x1C020108)
#define SCT2_MATCH3			(*(volatile uint32_t*)0x1C02010C)
#define SCT2_MATCH4			(*(volatile uint32_t*)0x1C020110)
#define SCT2_MATCH5			(*(volatile uint32_t*)0x1C020114)
#define SCT2_MATCH6			(*(volatile uint32_t*)0x1C020118)
#define SCT2_MATCH7			(*(volatile uint32_t*)0x1C02011C)
#define SCT2_MATCH0_L		(*(volatile uint16_t*)0x1C020100)
#define SCT2_MATCH1_L		(*(volatile uint16_t*)0x1C020104)
#define SCT2_MATCH2_L		(*(volatile uint16_t*)0x1C020108)
#define SCT2_MATCH3_L		(*(volatile uint16_t*)0x1C02010C)
#define SCT2_MATCH4_L		(*(volatile uint16_t*)0x1C020110)
#define SCT2_MATCH5_L		(*(volatile uint16_t*)0x1C020114)
#define SCT2_MATCH6_L		(*(volatile uint16_t*)0x1C020118)
#define SCT2_MATCH7_L		(*(volatile uint16_t*)0x1C02011C)
#define SCT2_MATCH0_H		(*(volatile uint16_t*)0x1C020100)
#define SCT2_MATCH1_H		(*(volatile uint16_t*)0x1C020104)
#define SCT2_MATCH2_H		(*(volatile uint16_t*)0x1C020108)
#define SCT2_MATCH3_H		(*(volatile uint16_t*)0x1C02010C)
#define SCT2_MATCH4_H		(*(volatile uint16_t*)0x1C020110)
#define SCT2_MATCH5_H		(*(volatile uint16_t*)0x1C020114)
#define SCT2_MATCH6_H		(*(volatile uint16_t*)0x1C020118)
#define SCT2_MATCH7_H		(*(volatile uint16_t*)0x1C02011C)
#define SCT2_CAP0			(*(volatile uint32_t*)0x1C020100)
#define SCT2_CAP1			(*(volatile uint32_t*)0x1C020104)
#define SCT2_CAP2			(*(volatile uint32_t*)0x1C020108)
#define SCT2_CAP3			(*(volatile uint32_t*)0x1C02010C)
#define SCT2_CAP4			(*(volatile uint32_t*)0x1C020110)
#define SCT2_CAP5			(*(volatile uint32_t*)0x1C020114)
#define SCT2_CAP6			(*(volatile uint32_t*)0x1C020118)
#define SCT2_CAP7			(*(volatile uint32_t*)0x1C02011C)
#define SCT2_CAP0_L			(*(volatile uint16_t*)0x1C020100)
#define SCT2_CAP1_L			(*(volatile uint16_t*)0x1C020104)
#define SCT2_CAP2_L			(*(volatile uint16_t*)0x1C020108)
#define SCT2_CAP3_L			(*(volatile uint16_t*)0x1C02010C)
#define SCT2_CAP4_L			(*(volatile uint16_t*)0x1C020110)
#define SCT2_CAP5_L			(*(volatile uint16_t*)0x1C020114)
#define SCT2_CAP6_L			(*(volatile uint16_t*)0x1C020118)
#define SCT2_CAP7_L			(*(volatile uint16_t*)0x1C02011C)
#define SCT2_CAP0_H			(*(volatile uint16_t*)0x1C020100)
#define SCT2_CAP1_H			(*(volatile uint16_t*)0x1C020104)
#define SCT2_CAP2_H			(*(volatile uint16_t*)0x1C020108)
#define SCT2_CAP3_H			(*(volatile uint16_t*)0x1C02010C)
#define SCT2_CAP4_H			(*(volatile uint16_t*)0x1C020110)
#define SCT2_CAP5_H			(*(volatile uint16_t*)0x1C020114)
#define SCT2_CAP6_H			(*(volatile uint16_t*)0x1C020118)
#define SCT2_CAP7_H			(*(volatile uint16_t*)0x1C02011C)
#define SCT2_MATCHREL0		(*(volatile uint32_t*)0x1C020200)
#define SCT2_MATCHREL1		(*(volatile uint32_t*)0x1C020204)
#define SCT2_MATCHREL2		(*(volatile uint32_t*)0x1C020208)
#define SCT2_MATCHREL3		(*(volatile uint32_t*)0x1C02020C)
#define SCT2_MATCHREL4		(*(volatile uint32_t*)0x1C020210)
#define SCT2_MATCHREL5		(*(volatile uint32_t*)0x1C020214)
#define SCT2_MATCHREL6		(*(volatile uint32_t*)0x1C020218)
#define SCT2_MATCHREL7		(*(volatile uint32_t*)0x1C02021C)
#define SCT2_MATCHREL0_L	(*(volatile uint16_t*)0x1C020200)
#define SCT2_MATCHREL1_L	(*(volatile uint16_t*)0x1C020204)
#define SCT2_MATCHREL2_L	(*(volatile uint16_t*)0x1C020208)
#define SCT2_MATCHREL3_L	(*(volatile uint16_t*)0x1C02020C)
#define SCT2_MATCHREL4_L	(*(volatile uint16_t*)0x1C020210)
#define SCT2_MATCHREL5_L	(*(volatile uint16_t*)0x1C020214)
#define SCT2_MATCHREL6_L	(*(volatile uint16_t*)0x1C020218)
#define SCT2_MATCHREL7_L	(*(volatile uint16_t*)0x1C02021C)
#define SCT2_MATCHREL0_H	(*(volatile uint16_t*)0x1C020202)
#define SCT2_MATCHREL1_H	(*(volatile uint16_t*)0x1C020206)
#define SCT2_MATCHREL2_H	(*(volatile uint16_t*)0x1C02020A)
#define SCT2_MATCHREL3_H	(*(volatile uint16_t*)0x1C02020E)
#define SCT2_MATCHREL4_H	(*(volatile uint16_t*)0x1C020212)
#define SCT2_MATCHREL5_H	(*(volatile uint16_t*)0x1C020216)
#define SCT2_MATCHREL6_H	(*(volatile uint16_t*)0x1C02021A)
#define SCT2_MATCHREL7_H	(*(volatile uint16_t*)0x1C02021E)
#define SCT2_CAPCTRL0		(*(volatile uint32_t*)0x1C020200)
#define SCT2_CAPCTRL1		(*(volatile uint32_t*)0x1C020204)
#define SCT2_CAPCTRL2		(*(volatile uint32_t*)0x1C020208)
#define SCT2_CAPCTRL3		(*(volatile uint32_t*)0x1C02020C)
#define SCT2_CAPCTRL4		(*(volatile uint32_t*)0x1C020210)
#define SCT2_CAPCTRL5		(*(volatile uint32_t*)0x1C020214)
#define SCT2_CAPCTRL6		(*(volatile uint32_t*)0x1C020218)
#define SCT2_CAPCTRL7		(*(volatile uint32_t*)0x1C02021C)
#define SCT2_CAPCTRL0_L		(*(volatile uint16_t*)0x1C020200)
#define SCT2_CAPCTRL1_L		(*(volatile uint16_t*)0x1C020204)
#define SCT2_CAPCTRL2_L		(*(volatile uint16_t*)0x1C020208)
#define SCT2_CAPCTRL3_L		(*(volatile uint16_t*)0x1C02020C)
#define SCT2_CAPCTRL4_L		(*(volatile uint16_t*)0x1C020210)
#define SCT2_CAPCTRL5_L		(*(volatile uint16_t*)0x1C020214)
#define SCT2_CAPCTRL6_L		(*(volatile uint16_t*)0x1C020218)
#define SCT2_CAPCTRL7_L		(*(volatile uint16_t*)0x1C02021C)
#define SCT2_CAPCTRL0_H		(*(volatile uint16_t*)0x1C020202)
#define SCT2_CAPCTRL1_H		(*(volatile uint16_t*)0x1C020206)
#define SCT2_CAPCTRL2_H		(*(volatile uint16_t*)0x1C02020A)
#define SCT2_CAPCTRL3_H		(*(volatile uint16_t*)0x1C02020E)
#define SCT2_CAPCTRL4_H		(*(volatile uint16_t*)0x1C020212)
#define SCT2_CAPCTRL5_H		(*(volatile uint16_t*)0x1C020216)
#define SCT2_CAPCTRL6_H		(*(volatile uint16_t*)0x1C02021A)
#define SCT2_CAPCTRL7_H		(*(volatile uint16_t*)0x1C02021E)
#define SCT2_EV0_STATE		(*(volatile uint32_t*)0x1C020300)
#define SCT2_EV0_CTRL		(*(volatile uint32_t*)0x1C020304)
#define SCT2_EV1_STATE		(*(volatile uint32_t*)0x1C020308)
#define SCT2_EV1_CTRL		(*(volatile uint32_t*)0x1C02030C)
#define SCT2_EV2_STATE		(*(volatile uint32_t*)0x1C020310)
#define SCT2_EV2_CTRL		(*(volatile uint32_t*)0x1C020314)
#define SCT2_EV3_STATE		(*(volatile uint32_t*)0x1C020318)
#define SCT2_EV3_CTRL		(*(volatile uint32_t*)0x1C02031C)
#define SCT2_EV4_STATE		(*(volatile uint32_t*)0x1C020320)
#define SCT2_EV4_CTRL		(*(volatile uint32_t*)0x1C020324)
#define SCT2_EV5_STATE		(*(volatile uint32_t*)0x1C020328)
#define SCT2_EV5_CTRL		(*(volatile uint32_t*)0x1C02032C)
#define SCT2_EV6_STATE		(*(volatile uint32_t*)0x1C020330)
#define SCT2_EV6_CTRL		(*(volatile uint32_t*)0x1C020334)
#define SCT2_EV7_STATE		(*(volatile uint32_t*)0x1C020338)
#define SCT2_EV7_CTRL		(*(volatile uint32_t*)0x1C02033C)
#define SCT2_EV8_STATE		(*(volatile uint32_t*)0x1C020340)
#define SCT2_EV8_CTRL		(*(volatile uint32_t*)0x1C020344)
#define SCT2_EV9_STATE		(*(volatile uint32_t*)0x1C020348)
#define SCT2_EV9_CTRL		(*(volatile uint32_t*)0x1C02034C)
#define SCT2_OUT0_SET		(*(volatile uint32_t*)0x1C020500)
#define SCT2_OUT0_CLR		(*(volatile uint32_t*)0x1C020504)
#define SCT2_OUT1_SET		(*(volatile uint32_t*)0x1C020508)
#define SCT2_OUT1_CLR		(*(volatile uint32_t*)0x1C02050C)
#define SCT2_OUT2_SET		(*(volatile uint32_t*)0x1C020510)
#define SCT2_OUT2_CLR		(*(volatile uint32_t*)0x1C020514)
#define SCT2_OUT3_SET		(*(volatile uint32_t*)0x1C020518)
#define SCT2_OUT3_CLR		(*(volatile uint32_t*)0x1C02051C)
#define SCT2_OUT4_SET		(*(volatile uint32_t*)0x1C020520)
#define SCT2_OUT4_CLR		(*(volatile uint32_t*)0x1C020524)
#define SCT2_OUT5_SET		(*(volatile uint32_t*)0x1C020528)
#define SCT2_OUT5_CLR		(*(volatile uint32_t*)0x1C02052C)

#define SCT3_CONFIG			(*(volatile uint32_t*)0x1C024000)
#define SCT3_CTRL			(*(volatile uint32_t*)0x1C024004)
#define SCT3_CTRL_L			(*(volatile uint16_t*)0x1C024004)
#define SCT3_CTRL_H			(*(volatile uint16_t*)0x1C024006)
#define SCT3_LIMIT			(*(volatile uint32_t*)0x1C024008)
#define SCT3_LIMIT_L		(*(volatile uint16_t*)0x1C024008)
#define SCT3_LIMIT_H		(*(volatile uint16_t*)0x1C02400A)
#define SCT3_HALT			(*(volatile uint32_t*)0x1C02400C)
#define SCT3_HALT_L			(*(volatile uint16_t*)0x1C02400C)
#define SCT3_HALT_H			(*(volatile uint16_t*)0x1C02400E)
#define SCT3_STOP			(*(volatile uint32_t*)0x1C024010)
#define SCT3_STOP_L			(*(volatile uint16_t*)0x1C024010)
#define SCT3_STOP_H			(*(volatile uint16_t*)0x1C024012)
#define SCT3_START			(*(volatile uint32_t*)0x1C024014)
#define SCT3_START_L		(*(volatile uint16_t*)0x1C024014)
#define SCT3_START_H		(*(volatile uint16_t*)0x1C024016)
#define SCT3_COUNT			(*(volatile uint32_t*)0x1C024040)
#define SCT3_COUNT_L		(*(volatile uint16_t*)0x1C024040)
#define SCT3_COUNT_H		(*(volatile uint16_t*)0x1C024042)
#define SCT3_STATE			(*(volatile uint32_t*)0x1C024044)
#define SCT3_STALE_L		(*(volatile uint16_t*)0x1C024044)
#define SCT3_STALE_H		(*(volatile uint16_t*)0x1C024046)
#define SCT3_INPUT			(*(volatile uint32_t*)0x1C024048)
#define SCT3_REGMODE		(*(volatile uint32_t*)0x1C02404C)
#define SCT3_REGMODE_L		(*(volatile uint32_t*)0x1C02404C)
#define SCT3_REGMODE_H		(*(volatile uint32_t*)0x1C02404E)
#define SCT3_OUTPUT			(*(volatile uint32_t*)0x1C024050)
#define SCT3_OUTPUTDIRCTRL	(*(volatile uint32_t*)0x1C024054)
#define SCT3_RES			(*(volatile uint32_t*)0x1C024058)
#define SCT3_DMAREQ0		(*(volatile uint32_t*)0x1C02405C)
#define SCT3_DMAREQ1		(*(volatile uint32_t*)0x1C024060)
#define SCT3_EVEN			(*(volatile uint32_t*)0x1C0240F0)
#define SCT3_EVFLAG			(*(volatile uint32_t*)0x1C0240F4)
#define SCT3_CONEN			(*(volatile uint32_t*)0x1C0240F8)
#define SCT3_CONFLAG		(*(volatile uint32_t*)0x1C0240FC)
#define SCT3_MATCH0			(*(volatile uint32_t*)0x1C024100)
#define SCT3_MATCH1			(*(volatile uint32_t*)0x1C024104)
#define SCT3_MATCH2			(*(volatile uint32_t*)0x1C024108)
#define SCT3_MATCH3			(*(volatile uint32_t*)0x1C02410C)
#define SCT3_MATCH4			(*(volatile uint32_t*)0x1C024110)
#define SCT3_MATCH5			(*(volatile uint32_t*)0x1C024114)
#define SCT3_MATCH6			(*(volatile uint32_t*)0x1C024118)
#define SCT3_MATCH7			(*(volatile uint32_t*)0x1C02411C)
#define SCT3_MATCH0_L		(*(volatile uint16_t*)0x1C024100)
#define SCT3_MATCH1_L		(*(volatile uint16_t*)0x1C024104)
#define SCT3_MATCH2_L		(*(volatile uint16_t*)0x1C024108)
#define SCT3_MATCH3_L		(*(volatile uint16_t*)0x1C02410C)
#define SCT3_MATCH4_L		(*(volatile uint16_t*)0x1C024110)
#define SCT3_MATCH5_L		(*(volatile uint16_t*)0x1C024114)
#define SCT3_MATCH6_L		(*(volatile uint16_t*)0x1C024118)
#define SCT3_MATCH7_L		(*(volatile uint16_t*)0x1C02411C)
#define SCT3_MATCH0_H		(*(volatile uint16_t*)0x1C024100)
#define SCT3_MATCH1_H		(*(volatile uint16_t*)0x1C024104)
#define SCT3_MATCH2_H		(*(volatile uint16_t*)0x1C024108)
#define SCT3_MATCH3_H		(*(volatile uint16_t*)0x1C02410C)
#define SCT3_MATCH4_H		(*(volatile uint16_t*)0x1C024110)
#define SCT3_MATCH5_H		(*(volatile uint16_t*)0x1C024114)
#define SCT3_MATCH6_H		(*(volatile uint16_t*)0x1C024118)
#define SCT3_MATCH7_H		(*(volatile uint16_t*)0x1C02411C)
#define SCT3_CAP0			(*(volatile uint32_t*)0x1C024100)
#define SCT3_CAP1			(*(volatile uint32_t*)0x1C024104)
#define SCT3_CAP2			(*(volatile uint32_t*)0x1C024108)
#define SCT3_CAP3			(*(volatile uint32_t*)0x1C02410C)
#define SCT3_CAP4			(*(volatile uint32_t*)0x1C024110)
#define SCT3_CAP5			(*(volatile uint32_t*)0x1C024114)
#define SCT3_CAP6			(*(volatile uint32_t*)0x1C024118)
#define SCT3_CAP7			(*(volatile uint32_t*)0x1C02411C)
#define SCT3_CAP0_L			(*(volatile uint16_t*)0x1C024100)
#define SCT3_CAP1_L			(*(volatile uint16_t*)0x1C024104)
#define SCT3_CAP2_L			(*(volatile uint16_t*)0x1C024108)
#define SCT3_CAP3_L			(*(volatile uint16_t*)0x1C02410C)
#define SCT3_CAP4_L			(*(volatile uint16_t*)0x1C024110)
#define SCT3_CAP5_L			(*(volatile uint16_t*)0x1C024114)
#define SCT3_CAP6_L			(*(volatile uint16_t*)0x1C024118)
#define SCT3_CAP7_L			(*(volatile uint16_t*)0x1C02411C)
#define SCT3_CAP0_H			(*(volatile uint16_t*)0x1C024100)
#define SCT3_CAP1_H			(*(volatile uint16_t*)0x1C024104)
#define SCT3_CAP2_H			(*(volatile uint16_t*)0x1C024108)
#define SCT3_CAP3_H			(*(volatile uint16_t*)0x1C02410C)
#define SCT3_CAP4_H			(*(volatile uint16_t*)0x1C024110)
#define SCT3_CAP5_H			(*(volatile uint16_t*)0x1C024114)
#define SCT3_CAP6_H			(*(volatile uint16_t*)0x1C024118)
#define SCT3_CAP7_H			(*(volatile uint16_t*)0x1C02411C)
#define SCT3_MATCHREL0		(*(volatile uint32_t*)0x1C024200)
#define SCT3_MATCHREL1		(*(volatile uint32_t*)0x1C024204)
#define SCT3_MATCHREL2		(*(volatile uint32_t*)0x1C024208)
#define SCT3_MATCHREL3		(*(volatile uint32_t*)0x1C02420C)
#define SCT3_MATCHREL4		(*(volatile uint32_t*)0x1C024210)
#define SCT3_MATCHREL5		(*(volatile uint32_t*)0x1C024214)
#define SCT3_MATCHREL6		(*(volatile uint32_t*)0x1C024218)
#define SCT3_MATCHREL7		(*(volatile uint32_t*)0x1C02421C)
#define SCT3_MATCHREL0_L	(*(volatile uint16_t*)0x1C024200)
#define SCT3_MATCHREL1_L	(*(volatile uint16_t*)0x1C024204)
#define SCT3_MATCHREL2_L	(*(volatile uint16_t*)0x1C024208)
#define SCT3_MATCHREL3_L	(*(volatile uint16_t*)0x1C02420C)
#define SCT3_MATCHREL4_L	(*(volatile uint16_t*)0x1C024210)
#define SCT3_MATCHREL5_L	(*(volatile uint16_t*)0x1C024214)
#define SCT3_MATCHREL6_L	(*(volatile uint16_t*)0x1C024218)
#define SCT3_MATCHREL7_L	(*(volatile uint16_t*)0x1C02421C)
#define SCT3_MATCHREL0_H	(*(volatile uint16_t*)0x1C024202)
#define SCT3_MATCHREL1_H	(*(volatile uint16_t*)0x1C024206)
#define SCT3_MATCHREL2_H	(*(volatile uint16_t*)0x1C02420A)
#define SCT3_MATCHREL3_H	(*(volatile uint16_t*)0x1C02420E)
#define SCT3_MATCHREL4_H	(*(volatile uint16_t*)0x1C024212)
#define SCT3_MATCHREL5_H	(*(volatile uint16_t*)0x1C024216)
#define SCT3_MATCHREL6_H	(*(volatile uint16_t*)0x1C02421A)
#define SCT3_MATCHREL7_H	(*(volatile uint16_t*)0x1C02421E)
#define SCT3_CAPCTRL0		(*(volatile uint32_t*)0x1C024200)
#define SCT3_CAPCTRL1		(*(volatile uint32_t*)0x1C024204)
#define SCT3_CAPCTRL2		(*(volatile uint32_t*)0x1C024208)
#define SCT3_CAPCTRL3		(*(volatile uint32_t*)0x1C02420C)
#define SCT3_CAPCTRL4		(*(volatile uint32_t*)0x1C024210)
#define SCT3_CAPCTRL5		(*(volatile uint32_t*)0x1C024214)
#define SCT3_CAPCTRL6		(*(volatile uint32_t*)0x1C024218)
#define SCT3_CAPCTRL7		(*(volatile uint32_t*)0x1C02421C)
#define SCT3_CAPCTRL0_L		(*(volatile uint16_t*)0x1C024200)
#define SCT3_CAPCTRL1_L		(*(volatile uint16_t*)0x1C024204)
#define SCT3_CAPCTRL2_L		(*(volatile uint16_t*)0x1C024208)
#define SCT3_CAPCTRL3_L		(*(volatile uint16_t*)0x1C02420C)
#define SCT3_CAPCTRL4_L		(*(volatile uint16_t*)0x1C024210)
#define SCT3_CAPCTRL5_L		(*(volatile uint16_t*)0x1C024214)
#define SCT3_CAPCTRL6_L		(*(volatile uint16_t*)0x1C024218)
#define SCT3_CAPCTRL7_L		(*(volatile uint16_t*)0x1C02421C)
#define SCT3_CAPCTRL0_H		(*(volatile uint16_t*)0x1C024202)
#define SCT3_CAPCTRL1_H		(*(volatile uint16_t*)0x1C024206)
#define SCT3_CAPCTRL2_H		(*(volatile uint16_t*)0x1C02420A)
#define SCT3_CAPCTRL3_H		(*(volatile uint16_t*)0x1C02420E)
#define SCT3_CAPCTRL4_H		(*(volatile uint16_t*)0x1C024212)
#define SCT3_CAPCTRL5_H		(*(volatile uint16_t*)0x1C024216)
#define SCT3_CAPCTRL6_H		(*(volatile uint16_t*)0x1C02421A)
#define SCT3_CAPCTRL7_H		(*(volatile uint16_t*)0x1C02421E)
#define SCT3_EV0_STATE		(*(volatile uint32_t*)0x1C024300)
#define SCT3_EV0_CTRL		(*(volatile uint32_t*)0x1C024304)
#define SCT3_EV1_STATE		(*(volatile uint32_t*)0x1C024308)
#define SCT3_EV1_CTRL		(*(volatile uint32_t*)0x1C02430C)
#define SCT3_EV2_STATE		(*(volatile uint32_t*)0x1C024310)
#define SCT3_EV2_CTRL		(*(volatile uint32_t*)0x1C024314)
#define SCT3_EV3_STATE		(*(volatile uint32_t*)0x1C024318)
#define SCT3_EV3_CTRL		(*(volatile uint32_t*)0x1C02431C)
#define SCT3_EV4_STATE		(*(volatile uint32_t*)0x1C024320)
#define SCT3_EV4_CTRL		(*(volatile uint32_t*)0x1C024324)
#define SCT3_EV5_STATE		(*(volatile uint32_t*)0x1C024328)
#define SCT3_EV5_CTRL		(*(volatile uint32_t*)0x1C02432C)
#define SCT3_EV6_STATE		(*(volatile uint32_t*)0x1C024330)
#define SCT3_EV6_CTRL		(*(volatile uint32_t*)0x1C024334)
#define SCT3_EV7_STATE		(*(volatile uint32_t*)0x1C024338)
#define SCT3_EV7_CTRL		(*(volatile uint32_t*)0x1C02433C)
#define SCT3_EV8_STATE		(*(volatile uint32_t*)0x1C024340)
#define SCT3_EV8_CTRL		(*(volatile uint32_t*)0x1C024344)
#define SCT3_EV9_STATE		(*(volatile uint32_t*)0x1C024348)
#define SCT3_EV9_CTRL		(*(volatile uint32_t*)0x1C02434C)
#define SCT3_OUT0_SET		(*(volatile uint32_t*)0x1C024500)
#define SCT3_OUT0_CLR		(*(volatile uint32_t*)0x1C024504)
#define SCT3_OUT1_SET		(*(volatile uint32_t*)0x1C024508)
#define SCT3_OUT1_CLR		(*(volatile uint32_t*)0x1C02450C)
#define SCT3_OUT2_SET		(*(volatile uint32_t*)0x1C024510)
#define SCT3_OUT2_CLR		(*(volatile uint32_t*)0x1C024514)
#define SCT3_OUT3_SET		(*(volatile uint32_t*)0x1C024518)
#define SCT3_OUT3_CLR		(*(volatile uint32_t*)0x1C02451C)
#define SCT3_OUT4_SET		(*(volatile uint32_t*)0x1C024520)
#define SCT3_OUT4_CLR		(*(volatile uint32_t*)0x1C024524)
#define SCT3_OUT5_SET		(*(volatile uint32_t*)0x1C024528)
#define SCT3_OUT5_CLR		(*(volatile uint32_t*)0x1C02452C)

/* WWDT */
#define WWDT_MOD		(*(volatile uint32_t*)0x4002C000)
#define WWDT_TC			(*(volatile uint32_t*)0x4002C004)
#define WWDT_FEED		(*(volatile uint32_t*)0x4002C008)
#define WWDT_TV			(*(volatile uint32_t*)0x4002C00C)
#define WWDT_WARNINT	(*(volatile uint32_t*)0x4002C014)
#define WWDT_WINDOW		(*(volatile uint32_t*)0x4002C018)

/* RTC */
#define RTC_CTRL		(*(volatile uint32_t*)0x40028000)
#define RTC_MATCH		(*(volatile uint32_t*)0x40028004)
#define RTC_COUNT		(*(volatile uint32_t*)0x40028008)
#define RTC_WAKE		(*(volatile uint32_t*)0x4002800C)

/* MRT */
#define MRT_INTVAL0		(*(volatile uint32_t*)0x400A0000)
#define MRT_TIMER0		(*(volatile uint32_t*)0x400A0004)
#define MRT_CTRL0		(*(volatile uint32_t*)0x400A0008)
#define MRT_STAT0		(*(volatile uint32_t*)0x400A000C)
#define MRT_INTVAL1		(*(volatile uint32_t*)0x400A0010)
#define MRT_TIMER1		(*(volatile uint32_t*)0x400A0014)
#define MRT_CTRL1		(*(volatile uint32_t*)0x400A0018)
#define MRT_STAT1		(*(volatile uint32_t*)0x400A001C)
#define MRT_INTVAL2		(*(volatile uint32_t*)0x400A0020)
#define MRT_TIMER2		(*(volatile uint32_t*)0x400A0024)
#define MRT_CTRL2		(*(volatile uint32_t*)0x400A0028)
#define MRT_STAT2		(*(volatile uint32_t*)0x400A002C)
#define MRT_INTVAL3		(*(volatile uint32_t*)0x400A0030)
#define MRT_TIMER3		(*(volatile uint32_t*)0x400A0034)
#define MRT_CTRL3		(*(volatile uint32_t*)0x400A0038)
#define MRT_STAT3		(*(volatile uint32_t*)0x400A003C)
#define MRT_IDLE_CH		(*(volatile uint32_t*)0x400A00F4)
#define MRT_IRQ_FALG	(*(volatile uint32_t*)0x400A00F8)

/* RIT */
#define	RIT_COMPVAL		(*(volatile uint32_t*)0x400B4000)
#define	RIT_MASK		(*(volatile uint32_t*)0x400B4004)
#define	RIT_CTRL		(*(volatile uint32_t*)0x400B4008)
#define	RIT_COUNTER		(*(volatile uint32_t*)0x400B400C)
#define	RIT_COMPVAL_H	(*(volatile uint32_t*)0x400B4010)
#define	RIT_MASK_H		(*(volatile uint32_t*)0x400B4014)
#define	RIT_COUNTER_H	(*(volatile uint32_t*)0x400B401C)

/* QEI */
#define	QEI_CON			(*(volatile uint32_t*)0x40058000)
#define	QEI_STAT		(*(volatile uint32_t*)0x40058004)
#define	QEI_CONF		(*(volatile uint32_t*)0x40058008)
#define	QEI_POS			(*(volatile uint32_t*)0x4005800C)
#define	QEI_MAXPOS		(*(volatile uint32_t*)0x40058010)
#define	QEI_CMPOS0		(*(volatile uint32_t*)0x40058014)
#define	QEI_CMPOS1		(*(volatile uint32_t*)0x40058018)
#define	QEI_CMPOS2		(*(volatile uint32_t*)0x4005801C)
#define	QEI_INXCNT		(*(volatile uint32_t*)0x40058020)
#define	QEI_INXCMP0		(*(volatile uint32_t*)0x40058024)
#define	QEI_LOAD		(*(volatile uint32_t*)0x40058028)
#define	QEI_TIME		(*(volatile uint32_t*)0x4005802C)
#define	QEI_VEL			(*(volatile uint32_t*)0x40058030)
#define	QEI_CAP			(*(volatile uint32_t*)0x40058034)
#define	QEI_VELCOMP		(*(volatile uint32_t*)0x40058038)
#define	QEI_FILTERPHA	(*(volatile uint32_t*)0x4005803C)
#define	QEI_FILTERPHB	(*(volatile uint32_t*)0x40058040)
#define	QEI_FILTERINX	(*(volatile uint32_t*)0x40058044)
#define	QEI_WINDOW		(*(volatile uint32_t*)0x40058048)
#define	QEI_INXCMP1		(*(volatile uint32_t*)0x4005804C)
#define	QEI_INXCMP2		(*(volatile uint32_t*)0x40058050)
#define	QEI_IEC			(*(volatile uint32_t*)0x40058FD8)
#define	QEI_IES			(*(volatile uint32_t*)0x40058FDC)
#define	QEI_INTSTAT		(*(volatile uint32_t*)0x40058FE0)
#define	QEI_IE			(*(volatile uint32_t*)0x40058FE4)
#define	QEI_CLR			(*(volatile uint32_t*)0x40058FE8)
#define	QEI_SET			(*(volatile uint32_t*)0x40058FEC)

/* USB */
#define	USB_DEVCMDSTAT		(*(volatile uint32_t*)0x1C00C000)
#define	USB_INFO			(*(volatile uint32_t*)0x1C00C004)
#define	USB_EPLISTSTAT		(*(volatile uint32_t*)0x1C00C008)
#define	USB_DATABUFSTART	(*(volatile uint32_t*)0x1C00C00C)
#define	USB_LPM				(*(volatile uint32_t*)0x1C00C010)
#define	USB_EPSKIP			(*(volatile uint32_t*)0x1C00C014)
#define	USB_EPINUSE			(*(volatile uint32_t*)0x1C00C018)
#define	USB_EPBUFCFG		(*(volatile uint32_t*)0x1C00C01C)
#define	USB_INTSTAT			(*(volatile uint32_t*)0x1C00C020)
#define	USB_INTEN			(*(volatile uint32_t*)0x1C00C024)
#define	USB_INTSETSTAT		(*(volatile uint32_t*)0x1C00C028)
#define	USB_INTROUTING		(*(volatile uint32_t*)0x1C00C02C)
#define	USB_EPTOGGLE		(*(volatile uint32_t*)0x1C00C034)

/* USART0, USART1, USART2 */
#define	USART0_CFG			(*(volatile uint32_t*)0x40040000)
#define	USART0_CTL			(*(volatile uint32_t*)0x40040004)
#define	USART0_STAT			(*(volatile uint32_t*)0x40040008)
#define	USART0_INTENSET		(*(volatile uint32_t*)0x4004000C)
#define	USART0_INTENCLR		(*(volatile uint32_t*)0x40040010)
#define	USART0_RXDAT		(*(volatile uint32_t*)0x40040014)
#define	USART0_RXDATSTAT	(*(volatile uint32_t*)0x40040018)
#define	USART0_TXDAT		(*(volatile uint32_t*)0x4004001C)
#define	USART0_BRG			(*(volatile uint32_t*)0x40040020)
#define	USART0_INTSTAT		(*(volatile uint32_t*)0x40040024)
#define	USART0_OSR			(*(volatile uint32_t*)0x40040028)
#define	USART0_ADDR			(*(volatile uint32_t*)0x4004002C)

#define	USART1_CFG			(*(volatile uint32_t*)0x40044000)
#define	USART1_CTL			(*(volatile uint32_t*)0x40044004)
#define	USART1_STAT			(*(volatile uint32_t*)0x40044008)
#define	USART1_INTENSET		(*(volatile uint32_t*)0x4004400C)
#define	USART1_INTENCLR		(*(volatile uint32_t*)0x40044010)
#define	USART1_RXDAT		(*(volatile uint32_t*)0x40044014)
#define	USART1_RXDATSTAT	(*(volatile uint32_t*)0x40044018)
#define	USART1_TXDAT		(*(volatile uint32_t*)0x4004401C)
#define	USART1_BRG			(*(volatile uint32_t*)0x40044020)
#define	USART1_INTSTAT		(*(volatile uint32_t*)0x40044024)
#define	USART1_OSR			(*(volatile uint32_t*)0x40044028)
#define	USART1_ADDR			(*(volatile uint32_t*)0x4004402C)

#define	USART2_CFG			(*(volatile uint32_t*)0x400C0000)
#define	USART2_CTL			(*(volatile uint32_t*)0x400C0004)
#define	USART2_STAT			(*(volatile uint32_t*)0x400C0008)
#define	USART2_INTENSET		(*(volatile uint32_t*)0x400C000C)
#define	USART2_INTENCLR		(*(volatile uint32_t*)0x400C0010)
#define	USART2_RXDAT		(*(volatile uint32_t*)0x400C0014)
#define	USART2_RXDATSTAT	(*(volatile uint32_t*)0x400C0018)
#define	USART2_TXDAT		(*(volatile uint32_t*)0x400C001C)
#define	USART2_BRG			(*(volatile uint32_t*)0x400C0020)
#define	USART2_INTSTAT		(*(volatile uint32_t*)0x400C0024)
#define	USART2_OSR			(*(volatile uint32_t*)0x400C0028)
#define	USART2_ADDR			(*(volatile uint32_t*)0x400C002C)

/* SPI0, SPI1 */
#define SPI0_CFG		(*(volatile uint32_t*)0x40048000)
#define SPI0_DLY		(*(volatile uint32_t*)0x40048004)
#define SPI0_STAT		(*(volatile uint32_t*)0x40048008)
#define SPI0_INTENSET	(*(volatile uint32_t*)0x4004800C)
#define SPI0_INTENCLR	(*(volatile uint32_t*)0x40048010)
#define SPI0_RXDAT		(*(volatile uint32_t*)0x40048014)
#define SPI0_TXDATCTL	(*(volatile uint32_t*)0x40048018)
#define SPI0_TXDAT		(*(volatile uint32_t*)0x4004801C)
#define SPI0_TXCTL		(*(volatile uint32_t*)0x40048020)
#define SPI0_DIV		(*(volatile uint32_t*)0x40048024)
#define SPI0_INTSTAT	(*(volatile uint32_t*)0x40048028)

#define SPI1_CFG		(*(volatile uint32_t*)0x4008C000)
#define SPI1_DLY		(*(volatile uint32_t*)0x4008C004)
#define SPI1_STAT		(*(volatile uint32_t*)0x4008C008)
#define SPI1_INTENSET	(*(volatile uint32_t*)0x4008C00C)
#define SPI1_INTENCLR	(*(volatile uint32_t*)0x4008C010)
#define SPI1_RXDAT		(*(volatile uint32_t*)0x4008C014)
#define SPI1_TXDATCTL	(*(volatile uint32_t*)0x4008C018)
#define SPI1_TXDAT		(*(volatile uint32_t*)0x4008C01C)
#define SPI1_TXCTL		(*(volatile uint32_t*)0x4008C020)
#define SPI1_DIV		(*(volatile uint32_t*)0x4008C024)
#define SPI1_INTSTAT	(*(volatile uint32_t*)0x4008C028)

/* I2C */
#define I2C_CFG			(*(volatile uint32_t*)0x40050000)
#define I2C_STAT		(*(volatile uint32_t*)0x40050004)
#define I2C_INTENSET	(*(volatile uint32_t*)0x40050008)
#define I2C_INTENCLR	(*(volatile uint32_t*)0x4005000C)
#define I2C_TIMEOUT		(*(volatile uint32_t*)0x40050010)
#define I2C_CLKDIV		(*(volatile uint32_t*)0x40050014)
#define I2C_INTSTAT		(*(volatile uint32_t*)0x40050018)
#define I2C_MSTCTL		(*(volatile uint32_t*)0x40050020)
#define I2C_MSTTIME		(*(volatile uint32_t*)0x40050024)
#define I2C_MSTDAT		(*(volatile uint32_t*)0x40050028)
#define I2C_SLVCTL		(*(volatile uint32_t*)0x40050040)
#define I2C_SLVDAT		(*(volatile uint32_t*)0x40050044)
#define I2C_SLVADR0		(*(volatile uint32_t*)0x40050048)
#define I2C_SLVADR1		(*(volatile uint32_t*)0x4005004C)
#define I2C_SLVADR2		(*(volatile uint32_t*)0x40050050)
#define I2C_SLVADR3		(*(volatile uint32_t*)0x40050054)
#define I2C_SLVQUAL0	(*(volatile uint32_t*)0x40050058)
#define I2C_MONRXDAT	(*(volatile uint32_t*)0x40050080)

/* C_CAN */
#define CCAN_CNTL			(*(volatile uint32_t*)0x400F0000)
#define CCAN_STAT			(*(volatile uint32_t*)0x400F0004)
#define CCAN_EC				(*(volatile uint32_t*)0x400F0008)
#define CCAN_BT				(*(volatile uint32_t*)0x400F000C)
#define CCAN_INT			(*(volatile uint32_t*)0x400F0010)
#define CCAN_TEST			(*(volatile uint32_t*)0x400F0014)
#define CCAN_BRPE			(*(volatile uint32_t*)0x400F0018)
#define CCAN_IF1_CMDREQ		(*(volatile uint32_t*)0x400F0020)
#define CCAN_IF1_CMDMSK_W	(*(volatile uint32_t*)0x400F0024)
#define CCAN_IF1_CMDMSK_R	(*(volatile uint32_t*)0x400F0024)
#define CCAN_IF1_MSK1		(*(volatile uint32_t*)0x400F0028)
#define CCAN_IF1_MSK2		(*(volatile uint32_t*)0x400F002C)
#define CCAN_IF1_ARB1		(*(volatile uint32_t*)0x400F0030)
#define CCAN_IF1_ARB2		(*(volatile uint32_t*)0x400F0034)
#define CCAN_IF1_MCTRL		(*(volatile uint32_t*)0x400F0038)
#define CCAN_IF1_DA1		(*(volatile uint32_t*)0x400F003C)
#define CCAN_IF1_DA2		(*(volatile uint32_t*)0x400F0040)
#define CCAN_IF1_DB1		(*(volatile uint32_t*)0x400F0044)
#define CCAN_IF1_DB2		(*(volatile uint32_t*)0x400F0048)
#define CCAN_IF2_CMDREQ		(*(volatile uint32_t*)0x400F0080)
#define CCAN_IF2_CMDMSK_W	(*(volatile uint32_t*)0x400F0084)
#define CCAN_IF2_CMDMSK_R	(*(volatile uint32_t*)0x400F0084)
#define CCAN_IF2_MSK1		(*(volatile uint32_t*)0x400F0088)
#define CCAN_IF2_MSK2		(*(volatile uint32_t*)0x400F008C)
#define CCAN_IF2_ARB1		(*(volatile uint32_t*)0x400F0090)
#define CCAN_IF2_ARB2		(*(volatile uint32_t*)0x400F0094)
#define CCAN_IF2_MCTRL		(*(volatile uint32_t*)0x400F0098)
#define CCAN_IF2_DA1		(*(volatile uint32_t*)0x400F009C)
#define CCAN_IF2_DA2		(*(volatile uint32_t*)0x400F00A0)
#define CCAN_IF2_DB1		(*(volatile uint32_t*)0x400F00A4)
#define CCAN_IF2_DB2		(*(volatile uint32_t*)0x400F00A8)
#define CCAN_TXREQ1			(*(volatile uint32_t*)0x400F0100)
#define CCAN_TXREQ2			(*(volatile uint32_t*)0x400F0104)
#define CCAN_ND1			(*(volatile uint32_t*)0x400F0120)
#define CCAN_ND2			(*(volatile uint32_t*)0x400F0124)
#define CCAN_IR1			(*(volatile uint32_t*)0x400F0140)
#define CCAN_IR2			(*(volatile uint32_t*)0x400F0144)
#define CCAN_MSGV1			(*(volatile uint32_t*)0x400F0160)
#define CCAN_MSGV2			(*(volatile uint32_t*)0x400F0164)
#define CCAN_CLKDIV			(*(volatile uint32_t*)0x400F0180)

/* ADC0, ADC1 */
#define	ADC0_CTRL			(*(volatile uint32_t*)0x40000000)
#define	ADC0_INSEL			(*(volatile uint32_t*)0x40000004)
#define	ADC0_SEQA_CTRL		(*(volatile uint32_t*)0x40000008)
#define	ADC0_SEQB_CTRL		(*(volatile uint32_t*)0x4000000C)
#define	ADC0_SEQA_GDAT		(*(volatile uint32_t*)0x40000010)
#define	ADC0_SEQB_GDAT		(*(volatile uint32_t*)0x40000014)
#define	ADC0_DAT			( (volatile uint32_t*)0x40000020)
#define	ADC0_DAT0			(*(volatile uint32_t*)0x40000020)
#define	ADC0_DAT1			(*(volatile uint32_t*)0x40000024)
#define	ADC0_DAT2			(*(volatile uint32_t*)0x40000028)
#define	ADC0_DAT3			(*(volatile uint32_t*)0x4000002C)
#define	ADC0_DAT4			(*(volatile uint32_t*)0x40000030)
#define	ADC0_DAT5			(*(volatile uint32_t*)0x40000034)
#define	ADC0_DAT6			(*(volatile uint32_t*)0x40000038)
#define	ADC0_DAT7			(*(volatile uint32_t*)0x4000003C)
#define	ADC0_DAT8			(*(volatile uint32_t*)0x40000040)
#define	ADC0_DAT9			(*(volatile uint32_t*)0x40000044)
#define	ADC0_DAT10			(*(volatile uint32_t*)0x40000048)
#define	ADC0_DAT11			(*(volatile uint32_t*)0x4000004C)
#define	ADC0_THR0_LOW		(*(volatile uint32_t*)0x40000050)
#define	ADC0_THR1_LOW		(*(volatile uint32_t*)0x40000054)
#define	ADC0_THR0_HIGH		(*(volatile uint32_t*)0x40000058)
#define	ADC0_THR1_HIGH		(*(volatile uint32_t*)0x4000005C)
#define	ADC0_CHAN_THRSEL	(*(volatile uint32_t*)0x40000060)
#define	ADC0_INTEN			(*(volatile uint32_t*)0x40000064)
#define	ADC0_FLAGS			(*(volatile uint32_t*)0x40000068)
#define	ADC0_TRM			(*(volatile uint32_t*)0x4000006C)

#define	ADC1_CTRL			(*(volatile uint32_t*)0x40080000)
#define	ADC1_INSEL			(*(volatile uint32_t*)0x40080004)
#define	ADC1_SEQA_CTRL		(*(volatile uint32_t*)0x40080008)
#define	ADC1_SEQB_CTRL		(*(volatile uint32_t*)0x4008000C)
#define	ADC1_SEQA_GDAT		(*(volatile uint32_t*)0x40080010)
#define	ADC1_SEQB_GDAT		(*(volatile uint32_t*)0x40080014)
#define	ADC1_DAT			( (volatile uint32_t*)0x40080020)
#define	ADC1_DAT0			(*(volatile uint32_t*)0x40080020)
#define	ADC1_DAT1			(*(volatile uint32_t*)0x40080024)
#define	ADC1_DAT2			(*(volatile uint32_t*)0x40080028)
#define	ADC1_DAT3			(*(volatile uint32_t*)0x4008002C)
#define	ADC1_DAT4			(*(volatile uint32_t*)0x40080030)
#define	ADC1_DAT5			(*(volatile uint32_t*)0x40080034)
#define	ADC1_DAT6			(*(volatile uint32_t*)0x40080038)
#define	ADC1_DAT7			(*(volatile uint32_t*)0x4008003C)
#define	ADC1_DAT8			(*(volatile uint32_t*)0x40080040)
#define	ADC1_DAT9			(*(volatile uint32_t*)0x40080044)
#define	ADC1_DAT10			(*(volatile uint32_t*)0x40080048)
#define	ADC1_DAT11			(*(volatile uint32_t*)0x4008004C)
#define	ADC1_THR0_LOW		(*(volatile uint32_t*)0x40080050)
#define	ADC1_THR1_LOW		(*(volatile uint32_t*)0x40080054)
#define	ADC1_THR0_HIGH		(*(volatile uint32_t*)0x40080058)
#define	ADC1_THR1_HIGH		(*(volatile uint32_t*)0x4008005C)
#define	ADC1_CHAN_THRSEL	(*(volatile uint32_t*)0x40080060)
#define	ADC1_INTEN			(*(volatile uint32_t*)0x40080064)
#define	ADC1_FLAGS			(*(volatile uint32_t*)0x40080068)
#define	ADC1_TRM			(*(volatile uint32_t*)0x4008006C)

/* DAC */
#define	DAC_VAL			(*(volatile uint32_t*)0x40004000)
#define	DAC_CTRL		(*(volatile uint32_t*)0x40004004)
#define	DAC_CNTVAL		(*(volatile uint32_t*)0x40004008)

/* ACMP */
#define	ACMP_CTRL		(*(volatile uint32_t*)0x40004000)
#define	ACMP_CMP0		(*(volatile uint32_t*)0x40004004)
#define	ACMP_CMPFILTR0	(*(volatile uint32_t*)0x40004008)
#define	ACMP_CMP1		(*(volatile uint32_t*)0x4000400C)
#define	ACMP_CMPFILTR1	(*(volatile uint32_t*)0x40004010)
#define	ACMP_CMP2		(*(volatile uint32_t*)0x40004014)
#define	ACMP_CMPFILTR2	(*(volatile uint32_t*)0x40004018)
#define	ACMP_CMP3		(*(volatile uint32_t*)0x4000401C)
#define	ACMP_CMPFILTR3	(*(volatile uint32_t*)0x40004020)

/* CRC */
#define	CRC_MODE		(*(volatile uint32_t*)0x1C010000)
#define	CRC_SEED		(*(volatile uint32_t*)0x1C010004)
#define	CRC_SUM			(*(volatile uint32_t*)0x1C010008)
#define	CRC_WR_DATA		(*(volatile uint32_t*)0x1C010008)

/* FLASH */
#define	FMC_FMSSTART	(*(volatile uint32_t*)0x400BC020)
#define	FMC_FMSSTOP		(*(volatile uint32_t*)0x400BC024)
#define	FMC_FMSW0		(*(volatile uint32_t*)0x400BC02C)

/* Cortex-M3 System timer */
#define	SYST_CSR	(*(volatile uint32_t*)0xE000E010)
#define	SYST_RVR	(*(volatile uint32_t*)0xE000E014)
#define	SYST_CVR	(*(volatile uint32_t*)0xE000E018)
#define	SYST_CALIB	(*(volatile uint32_t*)0xE000E01C)

/* Cortex-M3 NVIC */
#define	ISER		( (volatile uint32_t*)0xE000E100)
#define	ICER		( (volatile uint32_t*)0xE000E180)
#define	ISPR		( (volatile uint32_t*)0xE000E200)
#define	ICPR		( (volatile uint32_t*)0xE000E280)
#define	IABR		( (volatile uint32_t*)0xE000E300)
#define	IPR			( (volatile uint8_t *)0xE000E400)
#define	STIR		(*(volatile uint32_t*)0xE000EF00)

/* Cortex-M3 SCB */
#define	ACTLR		(*(volatile uint32_t*)0xE000E008)
#define	CPUID		(*(volatile uint32_t*)0xE000ED00)
#define	ICSR		(*(volatile uint32_t*)0xE000ED04)
#define	VTOR		(*(volatile uint32_t*)0xE000ED08)
#define	AIRCR		(*(volatile uint32_t*)0xE000ED0C)
#define	SCR			(*(volatile uint32_t*)0xE000ED10)
#define	CCR			(*(volatile uint32_t*)0xE000ED14)
#define	SHPR		( (volatile uint8_t *)0xE000ED14)
#define	CFSR		(*(volatile uint32_t*)0xE000ED28)
#define	MMSR		(*(volatile uint32_t*)0xE000ED28)
#define	BFSR		(*(volatile uint32_t*)0xE000ED29)
#define	UFSR		(*(volatile uint32_t*)0xE000ED2A)
#define	HFSR		(*(volatile uint32_t*)0xE000ED2C)
#define	MMFAR		(*(volatile uint32_t*)0xE000ED34)
#define	BFAR		(*(volatile uint32_t*)0xE000ED38)


/*-----------------------------------------------------------*/
/* LPC15xx IRQ number to be used by __enable_irqn(n) macro   */
/*-----------------------------------------------------------*/

#define	MemManage_IRQn	(-12)
#define	BusFault_IRQn	(-11)
#define	UsageFault_IRQn	(-10)
#define	SVC_IRQn		(-5)
#define	DebugMon_IRQn	(-4)
#define	PendSV_IRQn		(-2)
#define	SysTick_IRQn	(-1)
#define	WDT_IRQn		0
#define	BOD_IRQn		1
#define	FLASH_IRQn		2
#define	EE_IRQn			3
#define	DMA_IRQn		4
#define	GINT0_IRQn		5
#define	GINT1_IRQn		6
#define	PIN_INT0_IRQn	7
#define	PIN_INT1_IRQn	8
#define	PIN_INT2_IRQn	9
#define	PIN_INT3_IRQn	10
#define	PIN_INT4_IRQn	11
#define	PIN_INT5_IRQn	12
#define	PIN_INT6_IRQn	13
#define	PIN_INT7_IRQn	14
#define	RIT_IRQn		15
#define	SCT0_IRQn		16
#define	SCT1_IRQn		17
#define	SCT2_IRQn		18
#define	SCT3_IRQn		19
#define	MRT_IRQn		20
#define	UART0_IRQn		21
#define	UART1_IRQn		22
#define	UART2_IRQn		23
#define	I2C0_IRQn		24
#define	SPI0_IRQn		25
#define	SPI1_IRQn		26
#define	C_CAN0_IRQn		27
#define	USB_IRQn		28
#define	USB_FIQ_IRQn	29
#define	USB_WAKEUP_IRQn	30
#define	ADC0_SEQA_IRQn	31
#define	ADC0_SEQB_IRQn	32
#define	ADC0_THCMP_IRQn	33
#define	ADC0_OVR_IRQn	34
#define	ADC1_SEQA_IRQn	35
#define	ADC1_SEQB_IRQn	36
#define	ADC1_THCMP_IRQn	37
#define	ADC1_OVR_IRQn	38
#define	DAC_IRQn		39
#define	CMP0_IRQn		40
#define	CMP1_IRQn		41
#define	CMP2_IRQn		42
#define	CMP3_IRQn		43
#define	QEI_IRQn		44
#define	RTC_ALARM_IRQn	45
#define	RTC_WAKE_IRQn	46


/*----------------------------------------------------------------*/
/* Enable/disable fixed pin function with PINENABLE[1:0] register */
/*----------------------------------------------------------------*/
/* Macro definitions:
/   __disable_pin_function(bits)
/   __enable_pin_function(bits)
/
/ bits - A combination of peripheral ID flags to be attaced to the associated I/O pads.
*/

#define __disable_pin_function(b)	{ if ((b) & 0xFFFFFFFF) PINENABLE0 |= (uint32_t)(b); if ((b) & 0xFFFFFFFF00000000) PINENABLE1 |= (uint32_t)((uint64_t)(b)>>32); }
#define __enable_pin_function(b)	{ if ((b) & 0xFFFFFFFF) PINENABLE0 &= ~(uint32_t)(b); if ((b) & 0xFFFFFFFF00000000) PINENABLE1 &= ~(uint32_t)((uint64_t)(b)>>32); }
#define	ADC0_0_EN		0x0000000000000001
#define	ADC0_1_EN		0x0000000000000002
#define	ADC0_2_EN		0x0000000000000004
#define	ADC0_3_EN		0x0000000000000008
#define	ADC0_4_EN		0x0000000000000010
#define	ADC0_5_EN		0x0000000000000020
#define	ADC0_6_EN		0x0000000000000040
#define	ADC0_7_EN		0x0000000000000080
#define	ADC0_8_EN		0x0000000000000100
#define	ADC0_9_EN		0x0000000000000200
#define	ADC0_10_EN		0x0000000000000400
#define	ADC0_11_EN		0x0000000000000800
#define	ADC1_0_EN		0x0000000000001000
#define	ADC1_1_EN		0x0000000000002000
#define	ADC1_2_EN		0x0000000000004000
#define	ADC1_3_EN		0x0000000000008000
#define	ADC1_4_EN		0x0000000000010000
#define	ADC1_5_EN		0x0000000000020000
#define	ADC1_6_EN		0x0000000000040000
#define	ADC1_7_EN		0x0000000000080000
#define	ADC1_8_EN		0x0000000000100000
#define	ADC1_9_EN		0x0000000000200000
#define	ADC1_10_EN		0x0000000000400000
#define	ADC1_11_EN		0x0000000000800000
#define	DAC_OUT_EN		0x0000000001000000
#define	ACMP_I1_EN		0x0000000002000000
#define	ACMP_I2_EN		0x0000000004000000
#define	ACMP0_I3_EN		0x0000000008000000
#define	ACMP0_I4_EN		0x0000000010000000
#define	ACMP1_I3_EN		0x0000000020000000
#define	ACMP1_I4_EN		0x0000000040000000
#define	ACMP2_I3_EN		0x0000000080000000
#define	ACMP2_I4_EN		0x0000000100000000
#define	ACMP3_I3_EN		0x0000000200000000
#define	ACMP3_I4_EN		0x0000000400000000
#define	I2C0_SDA_EN		0x0000000800000000
#define	I2C0_SCL_EN		0x0000001000000000
#define	SCT0_OUT3_EN	0x0000002000000000
#define	SCT0_OUT4_EN	0x0000004000000000
#define	SCT0_OUT5_EN	0x0000008000000000
#define	SCT0_OUT6_EN	0x0000010000000000
#define	SCT0_OUT7_EN	0x0000020000000000
#define	SCT1_OUT3_EN	0x0000040000000000
#define	SCT1_OUT4_EN	0x0000080000000000
#define	SCT1_OUT5_EN	0x0000100000000000
#define	SCT1_OUT6_EN	0x0000200000000000
#define	SCT1_OUT7_EN	0x0000400000000000
#define	SCT2_OUT3_EN	0x0000800000000000
#define	SCT2_OUT4_EN	0x0001000000000000
#define	SCT2_OUT5_EN	0x0002000000000000
#define	SCT3_OUT3_EN	0x0004000000000000
#define	SCT3_OUT4_EN	0x0008000000000000
#define	SCT3_OUT5_EN	0x0010000000000000
#define	RESETN_EN		0x0020000000000000
#define	SWCLK_EN		0x0040000000000000
#define	SWDIO_EN		0x0080000000000000


/*-----------------------------------------------------------*/
/* Attach function to the port with PINASSIGN[15:0] register */
/*-----------------------------------------------------------*/
/* Macro definitions:
/   __attach_function(func, port, bit)
/   __detach_function(func)
/
/ func - Function ID to be attached or detached.
/ port - GPIO port numer (0-2) to be attached.
/ bit - GPIO bit number (0-31) to be attached.
*/

#define __attach_function(f,p,b)	PINASSIGN[f/4] = (PINASSIGN[f/4] & ~(0xFF<<((f%4)*8))) | ((p*32+b)<<((f%4)*8))
#define __detach_function(f)		PINASSIGN[f/4] |= (0xFF<<((f%4)*8))
#define UART0_TXD_O			0
#define UART0_RXD_I			1
#define UART0_RTS_O			2
#define UART0_CTS_I			3
#define UART0_SCLK_IO		4
#define UART1_TXD_O			5
#define UART1_RXD_I			6
#define UART1_RTS_O			7
#define UART1_CTS_I			8
#define UART1_SCLK_IO		9
#define UART2_TXD_O			10
#define UART2_RXD_I			11
#define UART2_SCLK_IO		12
#define SPI0_SCK_IO			13
#define SPI0_MOSI_IO		14
#define SPI0_MISO_IO		15
#define SPI0_SSELSN_0_IO	16
#define SPI0_SSELSN_1_IO	17
#define SPI0_SSELSN_2_IO	18
#define SPI0_SSELSN_3_IO	19
#define SPI1_SCK_IO			20
#define SPI1_MOSI_IO		21
#define SPI1_MISO_IO		22
#define SPI1_SSELSN_0_IO	23
#define SPI1_SSELSN_1_IO	24
#define CAN_TD1_O			25
#define CAN_RD1_I			26
#define USB_VBUS_I			28
#define SCT0_OUT0_O			29
#define SCT0_OUT1_O			30
#define SCT0_OUT2_O			31
#define SCT1_OUT0_O			32
#define SCT1_OUT1_O			33
#define SCT1_OUT2_O			34
#define SCT2_OUT0_O			35
#define SCT2_OUT1_O			36
#define SCT2_OUT2_O			37
#define SCT3_OUT0_O			38
#define SCT3_OUT1_O			39
#define SCT3_OUT2_O			40
#define SCT_ABORT0_I		41
#define SCT_ABORT1_I		42
#define ADC0_PIN_TRIG0_I	43
#define ADC0_PIN_TRIG1_I	44
#define ADC1_PIN_TRIG0_I	45
#define ADC1_PIN_TRIG1_I	46
#define DAC_PIN_TRIG_I		47
#define DAC_SHUTOFF_I		48
#define ACMP0_OUT_O			49
#define ACMP1_OUT_O			50
#define ACMP2_OUT_O			51
#define ACMP3_OUT_O			52
#define CLK_OUT_O			53
#define ROSC0_O				54
#define ROSC_RST0_I			55
#define USB_FRAME_TOG_O		56
#define QEI0_PHA_I			57
#define QEI0_PHB_I			58
#define QEI0_IDX_I			59
#define GPIO_INT_BMATCH_O	60
#define SWO_O				61


/*-----------------------------------------------------------*/
/* Control peripheral clock with SYSAHBCLKCTRL[1:0] register */
/*-----------------------------------------------------------*/
/* Macro definitions:
/   __enable_ahbclk(bits)
/   __disable_ahbclk(bits)
/
/ bits - A combination of peripheral ID flags to be clocked or not.
*/

#define	__enable_ahbclk(b)	{ if ((b) & 0xFFFFFFFF) SYSAHBCLKCTRL0 |= (uint32_t)(b); if ((b) & 0xFFFFFFFF00000000) SYSAHBCLKCTRL1 |= (uint32_t)((uint64_t)(b) >> 32); }
#define	__disable_ahbclk(b)	{ if ((b) & 0xFFFFFFFF) SYSAHBCLKCTRL0 &= ~(uint32_t)(b); if ((b) & 0xFFFFFFFF00000000) SYSAHBCLKCTRL1 &= ~(uint32_t)((uint64_t)(b) >> 32); }
#define PCSYS		0x0000000000000001
#define	PCROM		0x0000000000000002
#define	PCRAM1		0x0000000000000008
#define	PCRAM2		0x0000000000000010
#define	PCFLASH		0x0000000000000080
#define	PCEEPROM	0x0000000000000200
#define	PCMUX		0x0000000000000800
#define	PCSWM		0x0000000000001000
#define	PCIOCON		0x0000000000002000
#define	PCGPIO0		0x0000000000004000
#define	PCGPIO1		0x0000000000008000
#define	PCGPIO2		0x0000000000010000
#define	PCPINT		0x0000000000040000
#define	PCGINT		0x0000000000080000
#define	PCDMA		0x0000000000100000
#define	PCCRC		0x0000000000200000
#define	PCWWDT		0x0000000000400000
#define	PCRTC		0x0000000000800000
#define	PCADC0		0x0000000008000000
#define	PCADC1		0x0000000010000000
#define	PCDAC		0x0000000020000000
#define	PCACMP		0x0000000040000000
#define	PCMRT		0x0000000100000000
#define	PCRIT		0x0000000200000000
#define	PCSCT0		0x0000000400000000
#define	PCSCT1		0x0000000800000000
#define	PCSCT2		0x0000001000000000
#define	PCSCT3		0x0000002000000000
#define	PCSCTIPU	0x0000004000000000
#define	PCCCAN		0x0000008000000000
#define	PCSPI0		0x0000020000000000
#define	PCSPI1		0x0000040000000000
#define	PCI2C0		0x0000200000000000
#define	PCUART0		0x0002000000000000
#define	PCUART1		0x0004000000000000
#define	PCUART2		0x0008000000000000
#define	PCQEI		0x0020000000000000
#define	PCUSB		0x0080000000000000


/*--------------------------------------------------*/
/* Contorl peripheral power with PDRUNCFG register  */
/*--------------------------------------------------*/
/* Macro definitions:
/   __enable_power(bits)
/   __disable_power(bits)
/
/ bits - A combination of peripheral ID flags to be powered on or off.
*/

#define	__enable_power(b)	PDRUNCFG &= ~(b)
#define	__disable_power(b)	PDRUNCFG |= (b)
#define PDIRCOUT	0x00000008
#define PDIRC		0x00000010
#define PDFLASH		0x00000020
#define PDEEPROM	0x00000040
#define PDBOD		0x00000100
#define PDUSBPHY	0x00000200
#define PDADC0		0x00000400
#define PDADC1		0x00000800
#define PDDAC		0x00001000
#define PDACMP0		0x00002000
#define PDACMP1		0x00004000
#define PDACMP2		0x00008000
#define PDACMP3		0x00010000
#define PDIREF		0x00020000
#define PDTS		0x00040000
#define PDVDDADIV	0x00080000
#define PDWDTOSC	0x00100000
#define PDSYSOSC	0x00200000
#define PDSYSPLL	0x00400000
#define PDUSBPLL	0x00800000
#define PDSCTPLL	0x01000000


/*--------------------------------------------------*/
/* IAP API                                          */
/*--------------------------------------------------*/

#define IAP_ENTRY ((void(*)(uint32_t[], uint32_t[]))0x3000205)
#define IAP_PREWRRITE			50
#define IAP_WRISECTOR			51
#define IAP_ERSSECTOR			52
#define IAP_BLANK_CHECK_SECTOR	53
#define IAP_REPID				54
#define IAP_READ_BOOT_CODE		55
#define IAP_COMPARE				56
#define IAP_REINVOKE_ISP		57
#define IAP_READ_UID			58
#define IAP_ERASE_PAGE			59
#define IAP_EEPROM_WRITE		61
#define IAP_EEPROM_READ			62



/*--------------------------------------------------------------*/
/* Cortex-M3 core/peripheral access macros                      */
/*--------------------------------------------------------------*/

/* These are for only privileged mode */
#define __enable_irq() asm volatile ("CPSIE i\n")
#define __disable_irq() asm volatile ("CPSID i\n")
#define __enable_irqn(n) ISER[(n) / 32] = 1 << ((n) % 32)
#define __disable_irqn(n) ICER[(n) / 32] = 1 << ((n) % 32)
#define __test_irqn_enabled(n) (ISER[(n) / 32] & (1 << ((n) % 32)))
#define __set_irqn(n) ISPR[(n) / 32] = 1 << ((n) % 32)
#define __clear_irqn(n) ICPR[(n) / 32] = 1 << ((n) % 32)
#define __test_irqn(n) (ICPR[(n) / 32] & (1 << ((n) % 32)))
#define __test_irqn_active(n) (IABR[n / 32] & (1 << ((n) % 32)))
#define __set_irqn_priority(n,v) IPR[n] = (v)
#define __set_faultn_priority(n,v) SHPR[(n) + 16] = (v)
#define __get_MSP()			({uint32_t __rv; asm ("MRS %0, MSP\n"		: "=r" (__rv)); __rv;})
#define __get_PSP()			({uint32_t __rv; asm ("MRS %0, PSP\n"		: "=r" (__rv)); __rv;})
#define __get_PRIMASK() 	({uint32_t __rv; asm ("MRS %0, PRIMASK\n"	: "=r" (__rv)); __rv;})
#define __get_FAULTMASK()	({uint32_t __rv; asm ("MRS %0, FAULTMASK\n"	: "=r" (__rv)); __rv;})
#define __get_BASEPRI() 	({uint32_t __rv; asm ("MRS %0, BASEPRI\n"	: "=r" (__rv)); __rv;})
#define __get_CONTROL()		({uint32_t __rv; asm ("MRS %0, CONTROL\n"	: "=r" (__rv)); __rv;})
#define __set_MSP(arg)		{uint32_t __v=arg; asm ("MSR MSP, %0\n" 		:: "r" (__v));}
#define __set_PSP(arg)		{uint32_t __v=arg; asm ("MSR PSP, %0\n" 		:: "r" (__v));}
#define __set_PRIMASK(arg)	{uint32_t __v=arg; asm ("MSR PRIMASK, %0\n" 	:: "r" (__v));}
#define __set_FAULTMASK(arg) {uint32_t __v=arg; asm ("MSR FAULTMASK, %0\n" 	:: "r" (__v));}
#define __set_BASEPRI(arg)	{uint32_t __v=arg; asm ("MSR BASEPRI, %0\n" 	:: "r" (__v));}
#define __set_CONTORL(arg)	{uint32_t __v=arg; asm ("MSR CONTROL, %0\nISB\n" :: "r" (__v));}

/* These functions and macros are alternative of above for user mode */
#if USE_SV_SERVICE
#define __enable_irq_user()		asm volatile ("SVC #0\n")	/* CPSIE i */
#define __disable_irq_user()	asm volatile ("SVC #1\n")	/* CPSID i */
#define __enable_irq_user()		asm volatile ("SVC #2\n")	/* CPSIE f */
#define __disable_irq_user()	asm volatile ("SVC #3\n")	/* CPSID f */
uint32_t __get_scs_reg (volatile uint32_t* reg);			/* Read a register in SCS (to be defined in CRT) */
void __set_scs_reg (volatile uint32_t* reg, uint32_t val);	/* Write a register in SCS (to be defined in CRT) */
#define __enable_irqn_user(n) __set_scs_reg(&ISER[((n) / 32)], 1 << ((n) % 32))
#define __disable_irqn_user(n) __set_scs_reg(&ISCR[((n) / 32)], 1 << ((n) % 32))
#define __test_irqn_enabled_user(n) (__get_scs_reg(&ISCR[(n) / 32]) & (1 << ((n) % 32)))
#define __set_irqn_user(n) __set_scs_reg(&ISPR[((n) / 32)], 1 << ((n) % 32))
#define __clear_irqn_user(n) __set_scs_reg(&ICPR[((n) / 32)], 1 << ((n) % 32))
#define __test_irqn_user(n) (__get_scs_reg(&ICPR[(n) / 32]) & (1 << ((n) % 32)))
#define __test_active_irqn_user(n) (__get_scs_reg(&IABR[(n) / 32]) & (1 << ((n) % 32)))
#define __set_irqn_priority_user(n,v) __set_scs_reg(&IPR[n], (v))
#define __set_faultn_priority_user(n,v) __set_scs_reg(&SHPR[(n) + 16], (v))
#endif

/* These functions/macros can be used at user/privileged mode */
#define __REV(arg)		({uint32_t __r, __v=arg; asm ("REV %0,%1\n"   : "=r" (__r) : "r" (__v) ); __r;})
#define __REV16(arg)	({uint32_t __r, __v=arg; asm ("REV16 %0,%1\n" : "=r" (__r) : "r" (__v) ); __r;})
#define __REVSH(arg)	({uint32_t __r, __v=arg; asm ("REVSH %0,%1\n" : "=r" (__r) : "r" (__v) ); __r;})
#define __RBIT(arg)		({uint32_t __r, __v=arg; asm ("RBIT %0,%1\n"  : "=r" (__r) : "r" (__v) ); __r;})
#define __LDREXB(p)		({uint8_t __r;	asm ("LDREXB %0,[%1]\n" : "=r" (__r) : "r" (p)); __r;})
#define __LDREXH(p)		({uint16_t __r;	asm ("LDREXH %0,[%1]\n" : "=r" (__r) : "r" (p)); __r;})
#define __LDREXW(p)		({uint32_t __r;	asm ("LDREX  %0,[%1]\n" : "=r" (__r) : "r" (p)); __r;})
#define __STREXB(d,p)	({register uint32_t __r asm("r2"); register uint8_t __d asm("r1") = d; register volatile uint8_t *__p asm("r0") = p; asm ("STREXB %0,%2,[%1]\n" : "=r" (__r) : "r" (__p), "r" (__d)); __r;})
#define __STREXH(d,p)	({register uint32_t __r asm("r2"); register uint16_t __d asm("r1") = d; register volatile uint16_t *__p asm("r0") = p; asm ("STREXH %0,%2,[%1]\n" : "=r" (__r) : "r" (p), "r" (__d)); __r;})
#define __STREXW(d,p)	({register uint32_t __r asm("r2"); register uint32_t __d asm("r1") = d; register volatile uint32_t *__p asm("r0") = p; asm ("STREX  %0,%2,[%1]\n" : "=r" (__r) : "r" (p), "r" (__d)); __r;})
#define __CLREX() asm volatile ("CLREX\n")
#define __SEV() asm volatile ("SEV\n")
#define __WFE() asm volatile ("WFE\n")
#define __WFI() asm volatile ("WFI\n")
#define __ISB() asm volatile ("ISB\n")
#define __DSB() asm volatile ("DSB\n")
#define __DMB() asm volatile ("DMB\n")


/*--------------------------------------------------------------*/
/* Misc Macros                                                  */
/*--------------------------------------------------------------*/


#define	_BV(bit) (1<<(bit))

#define	IMPORT_BIN(sect, file, sym) asm (\
		".section " #sect "\n"\
		".balign 4\n"\
		".global " #sym "\n"\
		#sym ":\n"\
		".incbin \"" file "\"\n"\
		".global _sizeof_" #sym "\n"\
		".set _sizeof_" #sym ", . - " #sym "\n"\
		".balign 4\n"\
		".section \".text\"\n")

#define	IMPORT_BIN_PART(sect, file, ofs, siz, sym) asm (\
		".section " #sect "\n"\
		".balign 4\n"\
		".global " #sym "\n"\
		#sym ":\n"\
		".incbin \"" file "\"," #ofs "," #siz "\n"\
		".global _sizeof_" #sym "\n"\
		".set _sizeof_" #sym ", . - " #sym "\n"\
		".balign 4\n"\
		".section \".text\"\n")

/* Jump to secondary application */
#define JUMP_APP(appvt) asm (\
		"LDR SP, [%0]\n"          /* Initialize SP */\
		"LDR PC, [%0, #4]\n"      /* Go to reset vector */\
        : : "r" (appvt))


#endif /* __LPC15xx */
