#ifndef _UART_DEF
#define _UART_DEF


#define	F_MAINCLK	36000000	/* Main clock frequency */
#define	F_UARTCLK	(115200*16)	/* PCLK_UART generated by fractional divider. This should be the least common multiple of UARTx_BPS * 16. */

#define USE_UART0	1		/* Use UART0 function */
#define UART0_BPS 	115200	/* UART0 defalt bit rate (used when uart0_init(0)) */
#define UART0_TXB	0		/* Size of Tx buffer (0:polling) */
#define UART0_RXB	0		/* Size of Rx buffer (0:polling) */

#define USE_UART1	0		/* Use UART1 function */
#define UART1_BPS 	115200
#define UART1_TXB	0
#define UART1_RXB	0

#define USE_UART2	0		/* Use UART2 function */
#define UART2_BPS 	115200
#define UART2_TXB	0
#define UART2_RXB	0


#include "LPC15xx.h"


#if USE_UART0
void uart0_init (uint32_t);
int uart0_test (void);
void uart0_putc (uint8_t);
uint8_t uart0_getc (void);
#endif

#if USE_UART1
void uart1_init (uint32_t);
int uart1_test (void);
void uart1_putc (uint8_t);
uint8_t uart1_getc (void);
#endif

#if USE_UART2
void uart2_init (uint32_t);
int uart2_test (void);
void uart2_putc (uint8_t);
uint8_t uart2_getc (void);
#endif

#endif
